Represents the TreeGrid component.
<div id='treegrid'></div>
<script>
var treegridObj = new TreeGrid({ allowPaging: true });
treegridObj.appendTo('#treegrid');
</script>
Configures the TreeGrid aggregate rows.
Check the
Aggregates
for its configuration.
Defaults to []
boolean
If allowExcelExport
set to true, then it will allow the user to export treegrid to Excel file.
Check the
ExcelExport
to configure exporting document.
Defaults to false
boolean
If allowFiltering
is set to true the filter bar will be displayed.
If set to false the filter bar will not be displayed.
Filter bar allows the user to filter tree grid records with required criteria.
Defaults to false
boolean
If allowMultiSorting
set to true, then it will allow the user to sort multiple column in the treegrid.
allowSorting
should be true.
Defaults to true
boolean
If allowPaging
is set to true, pager renders.
Defaults to false
boolean
If allowPdfExport
set to true, then it will allow the user to export treegrid to Pdf file.
Check the
Pdfexport
to configure the exporting document.
Defaults to false
boolean
If allowReordering
is set to true, TreeGrid columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.
If TreeGrid is rendered with stacked headers, reordering is allowed only at the same level as the column headers.
Defaults to false
boolean
If allowResizing
is set to true, TreeGrid columns can be resized.
Defaults to false
boolean
If allowRowDragAndDrop
is set to true, you can drag and drop treegrid rows at another treegrid.
Defaults to false
boolean
If allowSelection
is set to true, it allows selection of (highlight row) TreeGrid records by clicking it.
Defaults to true
boolean
If allowSorting
is set to true, it allows sorting of treegrid records when column header is clicked.
Defaults to false
boolean
If allowTextWrap
set to true,
then text content will wrap to the next line when its text content exceeds the width of the Column Cells.
Defaults to false
boolean
If autoCheckHierarchy
is set to true, hierarchy checkbox selection is enabled in TreeGrid.
Defaults to false
string
Specifies the mapping property path for child records in data source
<div id="TreeGrid"></div>
import { TreeGrid } from '@syncfusion/ej2-treegrid';
let treegrid: TreeGrid = new TreeGrid(
{
dataSource: summaryRowData,
childMapping: 'children',
});
treegrid.appendTo('#TreeGrid');
Defaults to null
ClipMode
Defines the mode of clip. The available modes are,
Clip
: Truncates the cell content when it overflows its area.
Ellipsis
: Displays ellipsis when the cell content overflows its area.
EllipsisWithTooltip
: Displays ellipsis when the cell content overflows its area,
also it will display the tooltip while hover on ellipsis is applied..
Defaults to Syncfusion.EJ2.Grids.ClipMode.Ellipsis
TreeClipboard
clipboardModule
is used to handle TreeGrid copy action.
ColumnMenuItem[]
| ColumnMenuItemModel[]
columnMenuItems
defines both built-in and custom column menu items.
The available built-in items are,
AutoFitAll
- Auto fit the size of all columns.AutoFit
- Auto fit the current column.SortAscending
- Sort the current column in ascending order.SortDescending
- Sort the current column in descending order.Filter
- Filter options will show based on filterSettings property like filterbar, menu filter.Defaults to null
ColumnMenu
The columnMenuModule
is used to manipulate column menu items and its action in TreeGrid.
ColumnQueryModeType
columnQueryMode
provides options to retrieves data from the data source.Their types are
All
: It retrieves whole data source.Schema
: retrieves data for all the defined columns in TreeGrid from the data source.ExcludeHidden
: retrieves data only for visible columns of TreeGrid from the data Source.Defaults to All
ColumnModel[]
| string[]
| Column[]
Defines the schema of dataSource.
If the columns
declaration is empty or undefined then the columns
are automatically generated from data source.
<div id="TreeGrid"></div>
import { TreeGrid } from '@syncfusion/ej2-treegrid';
let treegrid: TreeGrid = new TreeGrid(
{
dataSource: summaryRowData,
childMapping: 'children',
treeColumnIndex: 0,
columns: [
{ field: 'taskID', headerText: 'Task ID', width: 130 },
{ field: 'taskName', width: 200, headerText: 'Task Name', width: 130 },
{ field: 'duration', headerText: 'Duration', width: 140 },
{ field: 'progress', headerText: 'Progress', width: 140 }
]
});
treegrid.appendTo('#TreeGrid');
Defaults to []
ContextMenuItem[]
| ContextMenuItemModel[]
contextMenuItems
defines both built-in and custom context menu items.
The available built-in items are,
AutoFitAll
- Auto fit the size of all columns.AutoFit
- Auto fit the current column.Edit
- Edit the current record.Delete
- Delete the current record.Save
- Save the edited record.Cancel
- Cancel the edited state.PdfExport
- Export the grid as Pdf format.ExcelExport
- Export the grid as Excel format.CsvExport
- Export the grid as CSV format.SortAscending
- Sort the current column in ascending order.SortDescending
- Sort the current column in descending order.FirstPage
- Go to the first page.PrevPage
- Go to the previous page.LastPage
- Go to the last page.NextPage
- Go to the next page.Defaults to null
ContextMenu
The contextMenuModule
is used to handle context menu items and its action in the TreeGrid.
string
copyHierarchyMode
Defines the copy clipboard types.
The available built-in items are,
Parent
- Copy the selected data with parent record.Child
- Copy the selected data with child record.Both
- Copy the selected data with both parent and child record.None
- Copy only the selected record.Defaults to Parent
Object
| DataManager
It is used to render TreeGrid table rows.
<div id="TreeGrid"></div>
import { TreeGrid } from '@syncfusion/ej2-treegrid';
import { summaryRowData } from './data-source';
let treegrid: TreeGrid = new TreeGrid(
{
dataSource: summaryRowData,
childMapping: 'children',
});
treegrid.appendTo('#TreeGrid');
Defaults to []
string
The detail template allows you to show or hide additional information about a particular row.
It accepts either the template string or the HTML element ID.
The editModule
is used to handle TreeGrid content manipulation.
Configures the edit settings.
Defaults to { allowAdding: false, allowEditing: false, allowDeleting: false, mode:‘Normal’,allowEditOnDblClick: true, showConfirmDialog: true, showDeleteConfirmDialog: false }
boolean
If enableAltRow
is set to true, the TreeGrid will render with e-altrow
CSS class to the alternative tr elements.
Check the
AltRow
to customize the styles of alternative rows.
Defaults to true
boolean
If enableAutoFill
is set to true, then the auto fill icon will displayed on cell selection for copy cells.
It requires the selection mode
to be Cell and cellSelectionMode
to be Box
.
Defaults to false
boolean
Specifies whether to load all the rows in collapsed state when the TreeGrid is rendered for the first time.
Defaults to false
boolean
If enableHover
is set to true, the row hover is enabled in the TreeGrid.
Defaults to false
boolean
If enableImmutableMode
is set to true, the TreeGrid will reuse old rows if it exists in the new result instead of
full refresh while performing the TreeGrid actions.
Defaults to false
boolean
If enableInfiniteScrolling
set to true, then the data will be loaded in TreeGrid when the scrollbar reaches the end.
This helps to load large dataset in TreeGrid.
Defaults to false
boolean
Enable or disable persisting component’s state between page reloads.
Defaults to false
boolean
Enable or disable rendering component in right to left direction.
Defaults to false
boolean
If enableVirtualization
set to true, then the TreeGrid will render only the rows visible within the view-port
and load subsequent rows on vertical scrolling. This helps to load large dataset in TreeGrid.
Defaults to false
string
Specifies the mapping property path for the expand status of a record in data source.
Defaults to null
Configures the filter settings of the TreeGrid.
Defaults to {columns: [], type: ‘FilterBar’, mode: ‘Immediate’, showFilterBarStatus: true, immediateModeDelay: 1500 , operators: {}}
number
Gets or sets the number of frozen columns.
Defaults to 0
number
Gets or sets the number of frozen rows.
Defaults to 0
GridLine
Defines the mode of TreeGrid lines. The available modes are,
Both
: Displays both horizontal and vertical TreeGrid lines.None
: No TreeGrid lines are displayed.Horizontal
: Displays the horizontal TreeGrid lines only.Vertical
: Displays the vertical TreeGrid lines only.Default
: Displays TreeGrid lines based on the theme.Defaults to Syncfusion.EJ2.Grids.GridLine.Default
string
Specifies whether record is parent or not for the remote data binding
Defaults to null
string
| number
Defines the scrollable height of the TreeGrid content.
Defaults to ‘auto’
string
Specifies the name of the field in the dataSource, which contains the id of that row.
<div id="TreeGrid"></div>
import { TreeGrid } from '@syncfusion/ej2-treegrid';
let treegrid: TreeGrid = new TreeGrid(
{
dataSource: projectData,
idMapping: 'TaskID',
parentIdMapping: 'parentID',
});
treegrid.appendTo('#TreeGrid');
Defaults to null
Configures the infinite scroll settings.
Defaults to { enableCache: false, maxBlocks: 5, initialBlocks: 5 }
KeyboardEvents
The keyboardModule
is used to manipulate keyboard interactions in TreeGrid.
boolean
If loadChildOnDemand
is enabled, parent records are render in expanded state.
Defaults to false
string
Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.
Defaults to ”
Configures the pager in the TreeGrid.
Defaults to {currentPage: 1, pageSize: 12, pageCount: 8, enableQueryString: false, pageSizes: false, template: null}
Page
The pagerModule
is used to manipulate paging in the TreeGrid.
string
Specifies the name of the field in the dataSource, which contains the parent’s id
<div id="TreeGrid"></div>
import { TreeGrid } from '@syncfusion/ej2-treegrid';
let treegrid: TreeGrid = new TreeGrid(
{
dataSource: projectData,
idMapping: 'TaskID',
parentIdMapping: 'parentID',
});
treegrid.appendTo('#TreeGrid');
Defaults to null
PrintMode
Defines the print modes. The available print modes are
AllPages
: Prints all pages of the TreeGrid.CurrentPage
: Prints the current page of the TreeGrid.Defaults to Syncfusion.EJ2.Grids.PrintMode.AllPages
Print
The printModule
is used to handle the printing feature of the TreeGrid.
Query
Defines the external Query
that will be executed along with data processing.
Defaults to null
Reorder
The reorderModule
is used to manipulate reordering in TreeGrid.
RowDD
The rowDragandDrop
is used to manipulate Row Reordering in TreeGrid.
RowDropSettingsModel
Configures the row drop settings of the TreeGrid.
number
Defines the height of TreeGrid rows.
Defaults to null
string
The row template that renders customized rows from the given template. By default, TreeGrid renders a table row for every data source item.
- It accepts either template string or HTML element ID.
- The row template must be a table row. Check the
Row Template
customization.
Configures the search settings of the TreeGrid.
Defaults to {search: [] , operators: {}}
number
The selectedRowIndex
allows you to select a row at initial rendering.
You can also get the currently selected row index.
Defaults to -1
Configures the selection settings.
Defaults to {mode: ‘Row’, cellSelectionMode: ‘Flow’, type: ‘Single’}
boolean
If showColumnChooser
is set to true, it allows you to dynamically show or hide columns.
Defaults to false
boolean
If showColumnMenu
set to true, then it will enable the column menu options in each columns.
Check the
Column menu
for its configuration.
Defaults to false
Sort
The sortModule
is used to manipulate sorting in TreeGrid.
Configures the sort settings of the TreeGrid.
Defaults to {columns:[]}
Configures the text wrap in the TreeGrid.
Defaults to {wrapMode:“Both”}
[]
toolbar
defines the ToolBar items of the TreeGrid.
It contains built-in and custom toolbar items.
If a string value is assigned to the toolbar
option, it is considered as the template for the whole TreeGrid ToolBar.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the TreeGrid’s Toolbar.
The available built-in ToolBar items are:
Defaults to null
Toolbar
The toolbarModule
is used to manipulate ToolBar items and its action in the TreeGrid.
number
Specifies the index of the column that needs to have the expander button.
Defaults to 0
string
| number
Defines the TreeGrid width.
Defaults to ‘auto’
Adds the handler to the given event listener.
Returns void
Adds a new record to the TreeGrid. Without passing parameters, it adds empty rows.
editSettings.allowEditing
should be true.
Parameter | Type | Description |
---|---|---|
data (optional) | Object |
Defines the new add record data. |
index (optional) | number |
Defines the row index to be added. |
position (optional) | string |
Defines the new row position to be added. |
Returns void
Appends the control within the given HTML element
Parameter | Type | Description |
---|---|---|
selector (optional) | string | HTMLElement |
Target element where control needs to be appended |
Returns void
Changes the column width to automatically fit its content to ensure that the width shows the content without wrapping/hiding.
- This method ignores the hidden columns.
- Uses the
autoFitColumns
method in thedataBound
event to resize at initial rendering.
Parameter | Type | Description |
---|---|---|
fieldNames (optional) | string | string[] |
Defines the column names. |
Returns void
Clears all the filtered rows of the TreeGrid.
Returns void
Deselects the current selected rows and cells.
Returns void
Clears all the sorted columns of the TreeGrid.
Returns void
Cancels edited state.
Returns void
Collapses All the rows
Returns void
Collapses the records at specific hierarchical level
Parameter | Type | Description |
---|---|---|
level | number |
Define the parent row level which needs to be collapsed |
Returns void
Collapses child rows
Parameter | Type | Description |
---|---|---|
row | HTMLTableRowElement |
Collapse the given row |
record (optional) | Object |
Collapse the given record |
Returns void
Copy the selected rows or cells data into clipboard.
Parameter | Type | Description |
---|---|---|
withHeader (optional) | boolean |
Specifies whether the column header text needs to be copied along with rows or cells. |
Returns void
Export TreeGrid data to CSV file.
Parameter | Type | Description |
---|---|---|
excelExportProperties (optional) | ExcelExportProperties |
Defines the export properties of the TreeGrid. |
isMultipleExport (optional) | boolean |
Define to enable multiple export. |
workbook (optional) | any |
Defines the Workbook if multiple export is enabled. |
isBlob (optional) | boolean |
If ‘isBlob’ set to true, then it will be returned as blob data. |
Returns Promise
Delete a record with Given options. If fieldName and data is not given then TreeGrid will delete the selected record.
editSettings.allowDeleting
should be true.
Parameter | Type | Description |
---|---|---|
fieldName (optional) | string |
Defines the primary key field, ‘Name of the column’. |
data (optional) | Object |
Defines the JSON data of the record to be deleted. |
Returns void
Delete any visible row by TR element.
Parameter | Type | Description |
---|---|---|
tr | HTMLTableRowElement |
Defines the table row element. |
Returns void
Destroys the component (detaches/removes all event handlers, attributes, classes, and empties the component element).
Returns void
To edit any particular cell using row index and cell index.
Parameter | Type | Description |
---|---|---|
rowIndex (optional) | number |
Defines row index to edit a particular cell. |
field (optional) | string |
Defines the field name of the column to perform cell edit. |
Returns void
Enables or disables ToolBar items.
Parameter | Type | Description |
---|---|---|
items | string[] |
Defines the collection of itemID of ToolBar items. |
isEnable | boolean |
Defines the items to be enabled or disabled. |
Returns void
If TreeGrid is in editable state, you can save a record by invoking endEdit.
Returns void
Export TreeGrid data to Excel file(.xlsx).
Parameter | Type | Description |
---|---|---|
excelExportProperties (optional) | ExcelExportProperties | TreeGridExcelExportProperties |
Defines the export properties of the Tree Grid. |
isMultipleExport (optional) | boolean |
Define to enable multiple export. |
workbook (optional) | any |
Defines the Workbook if multiple export is enabled. |
isBlob (optional) | boolean |
If ‘isBlob’ set to true, then it will be returned as blob data. |
Returns Promise
Expands All the rows
Returns void
Expands the records at specific hierarchical level
Parameter | Type | Description |
---|---|---|
level | number |
Expands the parent rows at given level |
Returns void
Expands child rows
Parameter | Type | Description |
---|---|---|
row | HTMLTableRowElement |
Expands the given row |
record (optional) | Object |
Expands the given record |
Returns void
Filters TreeGrid row by column name with the given options.
Parameter | Type | Description |
---|---|---|
fieldName | string |
Defines the field name of the column. |
filterOperator | string |
Defines the operator to filter records. |
filterValue | string | number | Date | boolean | number[] | string[] | Date[] | boolean[] |
Defines the value used to filter records. |
predicate (optional) | string |
Defines the relationship between one filter query and another by using AND or OR predicate. |
matchCase (optional) | boolean |
If match case is set to true, the TreeGrid filters the records with exact match. if false, it filters case insensitive records (uppercase and lowercase letters are treated the same). |
ignoreAccent (optional) | boolean |
If ignoreAccent is set to true, then filter ignores diacritic characters or accents while filtering. |
actualFilterValue (optional) | string |
Defines the actual filter value for filter column. |
actualOperator (optional) | string |
Defines the actual filter operator for filter column. |
Returns void
Gets the added, edited,and deleted data before bulk save to the DataSource in batch mode.
Returns Object
Gets a cell by row and column index.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Specifies the row index. |
columnIndex | number |
Specifies the column index. |
Returns Element
Get the records of checked rows.
Returns Object[]
Get the indexes of checked rows.
Returns number[]
Gets a Column by column name.
Parameter | Type | Description |
---|---|---|
field | string |
Specifies the column name. |
Returns Column
Gets a column by UID.
Parameter | Type | Description |
---|---|---|
uid | string |
Specifies the column UID. |
Returns Column
Gets the collection of column fields.
Returns string[]
Gets a column header by column name.
Parameter | Type | Description |
---|---|---|
field | string |
Specifies the column name. |
Returns Element
Gets a column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets a column header by UID.
Parameter | Type | Description |
---|---|---|
uid | string |
Specifies the column uid. |
Returns Element
Gets a column index by column name.
Parameter | Type | Description |
---|---|---|
field | string |
Specifies the column name. |
Returns number
Gets a column index by UID.
Parameter | Type | Description |
---|---|---|
uid | string |
Specifies the column UID. |
Returns number
Gets the columns from the TreeGrid.
Parameter | Type | Description |
---|---|---|
isRefresh (optional) | boolean |
Defined whether to update DOM |
Returns Column[]
Gets the content div of the TreeGrid.
Returns Element
Gets the content table of the TreeGrid.
Returns Element
Get current visible data of TreeGrid.
Returns Object[]
Gets the data module.
Returns Object
Gets all the TreeGrid’s data rows.
Returns Element[]
Gets the footer div of the TreeGrid.
Returns Element
Gets the footer table element of the TreeGrid.
Returns Element
Gets the header div of the TreeGrid.
Returns Element
Gets the header table element of the TreeGrid.
Returns Element
Returns the persistence data for component
Returns any
Gets a movable table cell by row and column index.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Specifies the row index. |
columnIndex | number |
Specifies the column index. |
Returns Element
Gets all the TreeGrid’s movable table data rows.
Returns Element[]
Gets a movable tables row by index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the row index. |
Returns Element
Gets the TreeGrid’s movable content rows from frozen treegrid.
Returns Element[]
Gets the pager of the TreeGrid.
Returns Element
Get the names of the primary key columns of the TreeGrid.
Returns string[]
Returns the route element of the component
Returns HTMLElement
Gets a row by index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the row index. |
Returns Element
Get a row information based on cell
Parameter | Type | Description |
---|---|---|
target | Element | EventTarget |
Target row element |
Returns RowInfo
Returns TreeGrid rows
Returns HTMLTableRowElement[]
Gets the collection of selected records.
Returns Object[]
Gets the collection of selected row and cell indexes.
Returns ISelectedCell[]
Gets the collection of selected row indexes.
Returns number[]
Gets the collection of selected rows.
Returns Element[]
Gets UID by column name.
Parameter | Type | Description |
---|---|---|
field | string |
Specifies the column name. |
Returns string
Gets the visible columns from the TreeGrid.
Returns Column[]
Get the visible records corresponding to rows visually displayed.
Returns Object[]
Navigates to the specified target page.
Parameter | Type | Description |
---|---|---|
pageNo | number |
Defines the page number to navigate. |
Returns void
Hides a column by column name.
Parameter | Type | Description |
---|---|---|
keys | string | string[] |
Defines a single or collection of column names. |
hideBy (optional) | string |
Defines the column key either as field name or header text. |
Returns void
Manually shown spinner needs to hide by hideSpinnner
.
Returns void
Column chooser can be displayed on screen by given position(X and Y axis).
Parameter | Type | Description |
---|---|---|
x (optional) | number |
Defines the X axis. |
y (optional) | number |
Defines the Y axis. |
Returns void
Paste data from clipboard to selected cells.
Parameter | Type | Description |
---|---|---|
data | string |
Specifies the date for paste. |
rowIndex | number |
Specifies the row index. |
colIndex | number |
Specifies the column index. |
Returns void
Export TreeGrid data to PDF document.
Parameter | Type | Description |
---|---|---|
pdfExportProperties (optional) | PdfExportProperties | TreeGridPdfExportProperties |
Defines the export properties of the Tree Grid. |
isMultipleExport (optional) | boolean |
Define to enable multiple export. |
pdfDoc (optional) | Object |
Defined the Pdf Document if multiple export is enabled. |
isBlob (optional) | boolean |
If ‘isBlob’ set to true, then it will be returned as blob data. |
Returns Promise
By default, prints all the pages of the TreeGrid and hides the pager.
You can customize print options using the
printMode
.
Returns void
Refreshes the TreeGrid header and content.
Returns void
Refreshes the TreeGrid column changes.
Parameter | Type | Description |
---|---|---|
refreshUI (optional) | boolean |
Defined whether to refresh the DOM |
Returns void
Refreshes the TreeGrid header.
Returns void
Removes the handler from the given event listener.
Returns void
Changes the TreeGrid column positions by field names.
Parameter | Type | Description |
---|---|---|
fromFName | string | string[] |
Defines the origin field name. |
toFName | string |
Defines the destination field name. |
Returns void
Reorder the rows based on given indexes and position
Parameter | Type | Description |
---|---|---|
fromIndexes | number[] |
Source indexes of rows |
toIndex | number |
Destination index of row |
position | string |
Defines drop position as above or below or child |
Returns void
Saves the cell that is currently edited. It does not save the value to the DataSource.
Returns void
Searches TreeGrid records using the given key.
You can customize the default search option by using the
searchSettings
.
Parameter | Type | Description |
---|---|---|
searchString | string |
Defines the key. |
Returns void
Selects a cell by the given index.
Parameter | Type | Description |
---|---|---|
cellIndex | IIndex |
Defines the row and column indexes. |
isToggle (optional) | boolean |
If set to true, then it toggles the selection. |
Returns void
Checked the checkboxes using rowIndexes.
Parameter | Type | Description |
---|---|---|
indexes | number[] |
row indexes |
Returns void
Selects a row by given index.
Parameter | Type | Description |
---|---|---|
index | number |
Defines the row index. |
isToggle (optional) | boolean |
If set to true, then it toggles the selection. |
Returns void
Selects a collection of rows by indexes.
Parameter | Type | Description |
---|---|---|
rowIndexes | number[] |
Specifies the row indexes. |
Returns void
Updates particular cell value based on the given primary key value.
Primary key column must be specified using
columns.isPrimaryKey
property.
Parameter | Type | Description |
---|---|---|
key | string | number |
Specifies the PrimaryKey value of dataSource. |
field | string |
Specifies the field name which you want to update. |
value | string | number | boolean | Date |
To update new value for the particular cell. |
Returns void
Updates and refresh the particular row values based on the given primary key value.
Primary key column must be specified using
columns.isPrimaryKey
property. @param {string| number} key - Specifies the PrimaryKey value of dataSource. @param {Object} rowData - To update new data for the particular row.
Returns void
Shows a column by its column name.
Parameter | Type | Description |
---|---|---|
keys | string | string[] |
Defines a single or collection of column names. |
showBy (optional) | string |
Defines the column key either as field name or header text. |
Returns void
By default, TreeGrid shows the spinner for all its actions. You can use this method to show spinner at your needed time.
Returns void
Sorts a column with the given options.
Parameter | Type | Description |
---|---|---|
columnName | string |
Defines the column name to be sorted. |
direction | SortDirection |
Defines the direction of sorting field. |
isMultiSort (optional) | boolean |
Specifies whether the previous sorted columns are to be maintained. |
Returns void
To edit any particular row by TR element.
Parameter | Type | Description |
---|---|---|
row (optional) | HTMLTableRowElement |
Defines the table row to be edited. |
Returns void
To update the specified cell by given value without changing into edited state.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Defines the row index. |
field | string |
Defines the column field. |
value | string | number | boolean | Date |
Defines the value to be changed. |
Returns void
Defines the text of external message.
Parameter | Type | Description |
---|---|---|
message | string |
Defines the message to update. |
Returns void
To update the specified row by given values without changing into edited state.
Parameter | Type | Description |
---|---|---|
index | number |
Defines the row index. |
data | Object |
Defines the data object to be updated. |
Returns void
Dynamically injects the required modules to the component.
Returns void
EmitType<PageEventArgs|FilterEventArgs|SortEventArgs|SearchEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs>
Triggers when TreeGrid actions such as sorting, filtering, paging etc., starts.
Triggers when TreeGrid actions such as sorting, filtering, paging etc. are completed.
EmitType<FailureEventArgs>
Triggers when any TreeGrid action failed to achieve the desired results.
EmitType<BatchAddArgs>
Triggers when records are added in batch mode.
EmitType<BatchCancelArgs>
Triggers before records are added in batch mode.
EmitType<BatchDeleteArgs>
Triggers when records are deleted in batch mode.
EmitType<BeforeBatchAddArgs>
Triggers before records are added in batch mode.
EmitType<BeforeBatchDeleteArgs>
Triggers before records are deleted in batch mode.
EmitType<BeforeBatchSaveArgs>
Triggers before records are saved in batch mode.
EmitType<BeforeCopyEventArgs>
Triggers before TreeGrid copy action.
EmitType<BeforeDataBoundArgs>
Triggers before data is bound to Tree Grid.
EmitType<Object>
Triggers before TreeGrid data is exported to Excel file.
EmitType<BeforePasteEventArgs>
Triggers before TreeGrid paste action.
EmitType<Object>
Triggers before TreeGrid data is exported to PDF document.
EmitType<PrintEventArgs>
Triggers before the print action starts.
EmitType<BeginEditArgs>
Triggers before the record is to be edit.
EmitType<CellDeselectEventArgs>
Triggers when a particular selected cell is deselected.
EmitType<CellDeselectEventArgs>
Triggers before the selected cell is deselecting.
EmitType<CellEditArgs>
Triggers when the cell is being edited.
EmitType<CellSaveArgs>
Triggers when cell is saved.
EmitType<CellSaveArgs>
Triggers when cell is saved.
EmitType<CellSelectEventArgs>
Triggers after a cell is selected.
EmitType<CellSelectingEventArgs>
Triggers before any cell selection occurs.
EmitType<CheckBoxChangeEventArgs>
Triggers when the check box state change in checkbox column.
EmitType<RowExpandingEventArgs>
Triggers after the record is collapsed.
EmitType<RowExpandingEventArgs>
Triggers while collapsing the TreeGrid record
EmitType<ColumnDragEventArgs>
Triggers when column header element is dragged (moved) continuously.
EmitType<ColumnDragEventArgs>
Triggers when column header element drag (move) starts.
EmitType<ColumnDragEventArgs>
Triggers when a column header element is dropped on the target column.
EmitType<MenuEventArgs>
Triggers when click on column menu.
EmitType<ColumnMenuOpenEventArgs>
Triggers before column menu opens.
EmitType<MenuEventArgs>
Triggers when click on context menu.
EmitType<BeforeOpenCloseMenuEventArgs>
Triggers before context menu opens.
EmitType<Object>
Triggers when the component is created.
EmitType<Object>
Triggers when data source is populated in the TreeGrid.
EmitType<DataSourceChangedEventArgs>
Triggers when the TreeGrid data is added, deleted and updated. Invoke the done method from the argument to start render after edit operation.
EmitType<DataStateChangeEventArgs>
Triggers when the TreeGrid actions such as Sorting, Paging etc., are done.
In this event,the current view data and total record count should be assigned to the dataSource
based on the action performed.
EmitType<DetailDataBoundEventArgs>
Triggers after detail row expands.
This event triggers at initial expand.
EmitType<ExcelExportCompleteArgs>
Triggers after TreeGrid data is exported to Excel file.
EmitType<ExcelHeaderQueryCellInfoEventArgs>
Triggers before exporting each header cell to Excel file. You can also customize the Excel cells.
EmitType<ExcelQueryCellInfoEventArgs>
Triggers before exporting each cell to Excel file. You can also customize the Excel cells.
EmitType<RowExpandedEventArgs>
Triggers after the record is expanded
EmitType<RowExpandingEventArgs>
Triggers while expanding the TreeGrid record
EmitType<HeaderCellInfoEventArgs>
Triggered for stacked header.
EmitType<Object>
This event allows customization of TreeGrid properties before rendering.
EmitType<PdfExportCompleteArgs>
Triggers after TreeGrid data is exported to PDF document.
EmitType<PdfHeaderQueryCellInfoEventArgs>
Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.
EmitType<PdfQueryCellInfoEventArgs>
Triggers before exporting each cell to PDF document. You can also customize the PDF cells.
EmitType<PrintEventArgs>
Triggers after print action is completed.
EmitType<QueryCellInfoEventArgs>
Triggered every time a request is made to access cell information, element, or data. This will be triggered before the cell element is appended to the TreeGrid element.
EmitType<RecordDoubleClickEventArgs>
Triggers when record is double clicked.
EmitType<ResizeArgs>
Triggers when column resize starts.
EmitType<ResizeArgs>
Triggers when column resize ends.
EmitType<ResizeArgs>
Triggers on column resizing.
EmitType<RowDataBoundEventArgs>
Triggered every time a request is made to access row information, element, or data. This will be triggered before the row element is appended to the TreeGrid element.
EmitType<RowDeselectEventArgs>
Triggers when a selected row is deselected.
EmitType<RowDeselectEventArgs>
Triggers before deselecting the selected row.
EmitType<RowDragEventArgs>
Triggers when row elements are dragged (moved) continuously.
EmitType<RowDragEventArgs>
Triggers when row element’s drag(move) starts.
EmitType<RowDragEventArgs>
Triggers when row element’s before drag(move).
EmitType<RowDragEventArgs>
Triggers when row elements are dropped on the target row.
EmitType<RowSelectEventArgs>
Triggers after a row is selected.
EmitType<RowSelectingEventArgs>
Triggers before row selection occurs.
EmitType<ClickEventArgs>
Triggers when toolbar item is clicked.

TreeTreeGridComponent
represents the react TreeTreeGrid.
<TreeTreeGridComponent dataSource={data} allowPaging={true} allowSorting={true}/>
Configures the TreeGrid aggregate rows.
Check the Aggregates for its configuration.
Defaults to []
boolean
Enables exporting the TreeGrid to an Excel file if set to true.
Check the ExcelExport documentation for more details.
Defaults to false
boolean
If allowFiltering
is set to true the filter bar will be displayed.
If set to false the filter bar will not be displayed.
Filter bar allows the user to filter tree grid records with required criteria.
Defaults to false
boolean
If allowMultiSorting
set to true, then it will allow the user to sort multiple column in the treegrid.
allowSorting
should be true.
Defaults to true
boolean
If allowPaging
is set to true, pager renders.
Defaults to false
boolean
Enables exporting the TreeGrid to a PDF file if set to true.
Check the PdfExport documentation for more details.
Defaults to false
boolean
If allowReordering
is set to true, TreeGrid columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.
If TreeGrid is rendered with stacked headers, reordering is allowed only at the same level as the column headers.
Defaults to false
boolean
If allowResizing
is set to true, TreeGrid columns can be resized.
Defaults to false
boolean
If allowRowDragAndDrop
is set to true, row reordering functionality is enabled, allowing rows to be dragged
and dropped within the TreeGrid or across TreeGrids.
This feature enables users to reorganize data dynamically via drag-and-drop operations.
Defaults to false
boolean
If allowSelection
is set to true, selection of (highlight row) TreeGrid records by clicking is allowed.
Defaults to true
boolean
If allowSorting
is set to true, it allows sorting of treegrid records when column header is clicked.
Defaults to false
boolean
If allowTextWrap
set to true,
then text content will wrap to the next line when its text content exceeds the width of the Column Cells.
Defaults to false
boolean
If autoCheckHierarchy
is set to true, hierarchy checkbox selection is enabled in TreeGrid.
Defaults to false
string
Specifies the mapping property path for child records in data source
import { TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import './App.css';
export default class App extends React.Component {
constructor() {
super(...arguments);
}
render() {
return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks'>
</TreeGridComponent>;
}
}
Defaults to null
ClipMode
Defines the options for printing the TreeGrid. The available print modes are:
AllPages
: Prints all pages of the TreeGrid.CurrentPage
: Prints only the current page of the TreeGrid.Defaults to Syncfusion.EJ2.Grids.ClipMode.Ellipsis
TreeClipboard
clipboardModule
is used to handle TreeGrid copy action.
ColumnMenuItem[]
| ColumnMenuItemModel[]
columnMenuItems
defines both built-in and custom column menu items.
The available built-in items are,
AutoFitAll
- Auto fit the size of all columns.AutoFit
- Auto fit the current column.SortAscending
- Sort the current column in ascending order.SortDescending
- Sort the current column in descending order.Filter
- Filter options will show based on filterSettings property like filterbar, menu filter.Defaults to null
ColumnMenu
The columnMenuModule
is used to manipulate column menu items and its action in TreeGrid.
ColumnQueryModeType
Specifies how data is retrieved from the data source for the TreeGrid. The available modes are:
All
: Retrieve the entire data source.Schema
: Retrieve data only for defined columns.ExcludeHidden
: Retrieve data only for visible columns in the TreeGrid.Defaults to All
ColumnModel[]
| string[]
| Column[]
Defines the schema of dataSource.
If the columns
declaration is empty or undefined then the columns
are automatically generated from data source.
import { TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import './App.css';
export default class App extends React.Component {
constructor() {
super(...arguments);
}
render() {
return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks'>
<ColumnsDirective>
<ColumnDirective field='taskID' headerText='Task ID' width='70' textAlign='Right'></ColumnDirective>
<ColumnDirective field='taskName' headerText='Task Name' width='200'></ColumnDirective>
<ColumnDirective field='duration' headerText='Duration' width='80' textAlign='Right'/>
<ColumnDirective field='progress' headerText='Progress' width='80' textAlign='Right'/>
</ColumnsDirective>
</TreeGridComponent>;
}
}
Defaults to []
ContextMenuItem[]
| ContextMenuItemModel[]
contextMenuItems
defines both built-in and custom context menu items.
The available built-in items are,
AutoFitAll
- Auto fit the size of all columns.AutoFit
- Auto fit the current column.Edit
- Edit the current record.Delete
- Delete the current record.Save
- Save the edited record.Cancel
- Cancel the edited state.PdfExport
- Export the grid as Pdf format.ExcelExport
- Export the grid as Excel format.CsvExport
- Export the grid as CSV format.SortAscending
- Sort the current column in ascending order.SortDescending
- Sort the current column in descending order.FirstPage
- Go to the first page.PrevPage
- Go to the previous page.LastPage
- Go to the last page.NextPage
- Go to the next page.Defaults to null
ContextMenu
The contextMenuModule
is used to handle context menu items and its action in the TreeGrid.
copyHierarchyMode
Defines the copy clipboard types.
The available built-in items are,
Parent
- Copy the selected data with parent record.Child
- Copy the selected data with child record.Both
- Copy the selected data with both parent and child record.None
- Copy only the selected record.Defaults to Parent
Object
| DataManager
It is used to render TreeGrid table rows.
import { TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import './App.css';
import { sampleData } from './data';
export default class App extends React.Component {
constructor() {
super(...arguments);
}
render() {
return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks'>
</TreeGridComponent>;
}
}
Defaults to []
string
| Function
The detail template allows you to show or hide additional information about a particular row.
It accepts either the template string or the HTML element ID.
The editModule
is used to handle TreeGrid content manipulation.
Configures the edit settings.
Defaults to { allowAdding: false, allowEditing: false, allowDeleting: false, mode:‘Normal’,allowEditOnDblClick: true, showConfirmDialog: true, showDeleteConfirmDialog: false }
boolean
If enableAdaptiveUI
is set to true, the pop-up UI will become adaptive to small screens,
and be used for filtering and other features.
<div id='treegrid'></div>
<script>
var treegridObj = new TreeGrid({ enableAdaptiveUI: true });
treegridObj.appendTo('#treegrid');
</script>
Defaults to false
boolean
If enableAltRow
is set to true, the TreeGrid will render with e-altrow
CSS class to the alternative tr elements.
Check the AltRow to customize the styles of alternative rows.
Defaults to true
boolean
If enableAutoFill
is set to true, then the auto fill icon will displayed on cell selection for copy cells.
It requires the selection mode
to be Cell and cellSelectionMode
to be Box
.
Defaults to false
boolean
Specifies whether to load all rows in a collapsed state when the TreeGrid is initially rendered. This setting is particularly useful when dealing with large datasets, as it helps enhance loading performance by reducing initial data rendering.
Defaults to false
boolean
Enables column virtualization in the TreeGrid. When set to true
, only columns visible within the viewport are rendered.
Additional columns are loaded as you horizontally scroll. This is beneficial for rendering large datasets efficiently.
Defaults to false
boolean
If enableHover
is set to true, the row hover is enabled in the TreeGrid.
Defaults to false
boolean
Determines whether to sanitize untrusted HTML content in the TreeGrid. If true
, potentially harmful HTML strings
and scripts are sanitized before rendering to protect against XSS attacks.
Defaults to false
boolean
If enableImmutableMode
is set to true, the TreeGrid will reuse old rows if it exists in the new result instead of
full refresh while performing the TreeGrid actions.
Defaults to false
boolean
Enables infinite scrolling in the TreeGrid. When set to true
, additional data is loaded as the scrollbar
reaches the end. Useful for handling large datasets.
Defaults to false
boolean
Enable or disable persisting component’s state between page reloads.
Defaults to false
boolean
Enable or disable rendering component in right to left direction.
Defaults to false
boolean
Specifies whether to display shimmer effect during scrolling action in virtual scrolling feature. If disabled, spinner is shown instead of shimmer effect.
Defaults to true
boolean
If enableVirtualization
set to true, then the TreeGrid will render only the rows visible within the view-port
and load subsequent rows on vertical scrolling. This helps to load large dataset in TreeGrid.
Defaults to false
string
Specifies the mapping property path for the expand status of a record in data source.
Defaults to null
Configures the filter settings of the TreeGrid.
Defaults to {columns: [], type: ‘FilterBar’, mode: ‘Immediate’, showFilterBarStatus: true, immediateModeDelay: 1500 , operators: {}}
number
Specifies the number of columns that should remain visible and fixed on the left side of the TreeGrid during horizontal scrolling. This feature ensures key columns, such as identifiers, stay visible while users scroll through data.
Defaults to 0
number
Specifies the number of rows that should remain visible and fixed at the top of the TreeGrid during scrolling. This feature helps improve readability in data-heavy grids by keeping the header rows or key rows visible.
Defaults to 0
GridLine
Defines how TreeGrid content lines are displayed, determining the visibility of vertical and horizontal lines.
Both
: Displays both horizontal and vertical grid lines.None
: Hides both horizontal and vertical grid lines.Horizontal
: Displays only horizontal grid lines.Vertical
: Displays only vertical grid lines.Default
: Adjusts line visibility based on the theme.Defaults to Syncfusion.EJ2.Grids.GridLine.Default
string
Specifies whether record is parent or not for the remote data binding
Defaults to null
string
| number
Defines the scrollable height of the TreeGrid content.
Defaults to ‘auto’
string
Specifies the name of the field in the dataSource, which contains the id of that row.
import { TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import './App.css';
export default class App extends React.Component {
constructor() {
super(...arguments);
}
render() {
return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} idMapping='TaskID' parentIdMapping='parentID'>
</TreeGridComponent>;
}
}
Defaults to null
Configures settings for infinite scrolling.
Defaults to { enableCache: false, maxBlocks: 5, initialBlocks: 5 }
KeyboardEvents
The keyboardModule
is used to manipulate keyboard interactions in TreeGrid.
boolean
When enabled, only parent records would be rendered during the initial render and child records will be loaded only when expanding a parent record. This property is only applicable for remote data binding. Loading child records on demand can improve the performance of data-bound controls with a large number of records. Child records are only loaded when they are requested, rather than loading all child records at once.
Defaults to true
Configures the loading indicator of the Tree Grid. Specifies whether to display spinner or shimmer effect during the waiting time on any actions (paging, sorting, filtering, CRUD operations) performed in Tree Grid.
Defaults to {indicatorType: ‘Spinner’}
string
Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.
Defaults to ”
Configures the pager in the TreeGrid.
Defaults to {currentPage: 1, pageSize: 12, pageCount: 8, enableQueryString: false, pageSizes: false, template: null}
Page
The pagerModule
is used to manipulate paging in the TreeGrid.
string
Specifies the name of the field in the dataSource, which contains the parent’s id
import { TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import './App.css';
export default class App extends React.Component {
constructor() {
super(...arguments);
}
render() {
return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} idMapping='TaskID' parentIdMapping='parentID'>
</TreeGridComponent>;
}
}
Defaults to null
PrintMode
Defines the options for printing the TreeGrid. The available print modes are:
AllPages
: Prints all pages of the TreeGrid.CurrentPage
: Prints only the current page of the TreeGrid.Defaults to Syncfusion.EJ2.Grids.PrintMode.AllPages
Print
The printModule
is used to handle the printing feature of the TreeGrid.
Query
Defines the external Query that will be executed along with data processing.
Defaults to null
Reorder
The reorderModule
is used to manipulate reordering in TreeGrid.
RowDD
The rowDragandDrop
is used to manipulate Row Reordering in TreeGrid.
RowDropSettingsModel
Configures the row drop settings of the TreeGrid.
number
Defines the height of TreeGrid rows.
Defaults to null
string
| Function
The row template that renders customized rows from the given template. By default, TreeGrid renders a table row for every data source item.
- It accepts either template string or HTML element ID.
- The row template must be a table row. Check the Row Template customization.
Configures the search settings of the TreeGrid.
Defaults to {search: [] , operators: {}}
number
Specifies the index of the row to be selected upon initial rendering. Also retrieves the index of the currently selected row.
Defaults to -1
Configures the selection behavior.
Defaults to {mode: ‘Row’, cellSelectionMode: ‘Flow’, type: ‘Single’}
boolean
If showColumnChooser
is set to true, it allows you to dynamically show or hide columns.
Defaults to false
boolean
If showColumnMenu
set to true, then it will enable the column menu options in each columns.
Check the Column menu for its configuration.
Defaults to false
Sort
The sortModule
is used to manipulate sorting in TreeGrid.
Configures the sort settings of the TreeGrid.
Defaults to {columns:[]}
Configures the text wrap in the TreeGrid.
Defaults to {wrapMode:“Both”}
[]
toolbar
defines the ToolBar items of the TreeGrid.
It contains built-in and custom toolbar items.
If a string value is assigned to the toolbar
option, it is considered as the template for the whole TreeGrid ToolBar.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the TreeGrid’s Toolbar.
The available built-in ToolBar items are:
Defaults to null
Toolbar
The toolbarModule
is used to manipulate ToolBar items and its action in the TreeGrid.
number
Specifies the index of the column that needs to have the expander button.
Defaults to 0
string
| number
Defines the TreeGrid width.
Defaults to ‘auto’
Adds a new record to the TreeGrid at the specified position or default location.
Parameter | Type | Description |
---|---|---|
data (optional) | Object |
Object containing the data for the new record. If omitted, an empty row is added. |
index (optional) | number |
The index at which the new row should be added. |
position (optional) | RowPosition |
Specifies the position of the new row (e.g., before, after or child). > Requires editSettings.allowAdding to be true. |
Returns void
Adjusts column widths to fit their content, ensuring content is displayed without wrapping or truncation.
autoFitColumns
method during the dataBound
event for initial rendering.Parameter | Type | Description |
---|---|---|
fieldNames (optional) | string | string[] |
The name(s) of the column(s) to be auto-fitted. |
Returns void
Clears all filters applied to the TreeGrid, restoring the view to show all records. This method is useful for resetting the grid to its unfiltered state.
Returns void
Deselects all selected rows and cells within the TreeGrid. Resets the selection state of the grid, which is useful after bulk operations.
Returns void
Clears all the sorted columns in the TreeGrid.
Returns void
Cancels the current edit operation on the TreeGrid. This method discards changes made to the row and exits the edit mode without saving.
Returns void
Collapses all rows in the TreeGrid, hiding all child rows and leaving only parent nodes visible. This method can be used to quickly minimize the view to only top-level data, which is helpful for summarizing or performing broad overviews of the dataset.
Returns void
Collapses all the records at the specified hierarchical level within the TreeGrid. This function helps in hiding child rows for all parent nodes at a given level, effectively reducing the visible depth of the hierarchical structure.
Parameter | Type | Description |
---|---|---|
level | number |
The hierarchical level at which parent rows should be collapsed. |
Returns void
Collapses a specific record identified by the provided primary key value. This method is useful for collapsing particular node in the TreeGrid when the parent rows need to be targeted individually by their unique key.
Parameter | Type | Description |
---|---|---|
key | Object |
The primary key value of the record to be collapsed. |
Returns void
Collapses the specified parent row in the TreeGrid. This method collapses the row associated with the provided HTMLTableRowElement, hiding any of its displayed child rows. It is typically used to manage the visibility of hierarchical data within a tree structure.
Parameter | Type | Description |
---|---|---|
row | HTMLTableRowElement |
The HTMLTableRowElement representing the parent row whose child rows are to be collapsed. |
record (optional) | Object |
(Optional) The data record associated with the row being collapsed. This can be used to access or manipulate the underlying data when collapsing the row. |
key (optional) | Object |
(Optional) The primary key value of the record. It can be used to identify the target record uniquely when collapsing the row, especially in cases where the row or record data needs to be referenced or logged. |
Returns void
Copies the data of selected rows or cells to the clipboard. This method supports including headers for better context when pasting elsewhere.
Parameter | Type | Description |
---|---|---|
withHeader (optional) | boolean |
(Optional) If true, includes column headers in the copied data. |
Returns void
Exports the TreeGrid data to a CSV file.
Parameter | Type | Description |
---|---|---|
excelExportProperties (optional) | ExcelExportProperties |
The properties used to configure the CSV export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
workbook (optional) | any |
The workbook instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Deletes a record based on specified criteria or the selected record if none specified.
Parameter | Type | Description |
---|---|---|
fieldName (optional) | string |
The name of the primary key field. |
data (optional) | Object |
The data object representing the record to delete. |
Returns void
Deletes a visible row from the TreeGrid using its HTML element. Apply this method when handling row deletions through DOM manipulations.
Parameter | Type | Description |
---|---|---|
tr | HTMLTableRowElement |
The table row element to remove. |
Returns void
Destroys the TreeGrid component by detaching event handlers, removing attributes and classes, and clearing the component’s DOM elements. This method ensures that all resources used by the TreeGrid are properly released and the component is cleaned up from the DOM to prevent memory leaks.
Returns void
Begins editing of a specific cell using row and field indices. Customers can programmatically specify which cell to edit without user input.
Parameter | Type | Description |
---|---|---|
rowIndex (optional) | number |
The index of the row containing the cell. |
field (optional) | string |
The field name of the cell to edit. |
Returns void
Enables or disables specified ToolBar items within the TreeGrid. This facilitates dynamic control of toolbar actions based on application logic.
Parameter | Type | Description |
---|---|---|
items | string[] |
Array of ToolBar item IDs to enable or disable. |
isEnable | boolean |
Boolean flag to determine whether to enable (true) or disable (false) items. |
Returns void
Commits the edits made to a record in edit mode, updating the data source. Use this method to finalize changes for rows in edit mode, ensuring persistence.
Returns void
Exports the TreeGrid data to an Excel file (.xlsx).
Parameter | Type | Description |
---|---|---|
excelExportProperties (optional) | ExcelExportProperties | TreeGridExcelExportProperties |
The properties used to configure the Excel export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
workbook (optional) | any |
The workbook instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Expands all rows in the TreeGrid, making the full hierarchy visible. This method should be used with caution on large datasets, as it makes all nodes and their child rows visible, which might affect performance.
Returns void
Expands all the records at the specified hierarchical level within the TreeGrid. This method is useful for visually expanding data at a certain depth, making all parent rows visible at the given level and their child rows accessible.
Parameter | Type | Description |
---|---|---|
level | number |
The hierarchical level at which parent rows should be expanded. |
Returns void
Expands a specific record identified by the provided primary key value. This method is useful for expanding particular node in the TreeGrid when the parent rows need to be targeted individually by their unique key.
Parameter | Type | Description |
---|---|---|
key | Object |
The primary key value of the record to be expanded. |
Returns void
Expands the specified parent row within the TreeGrid to reveal its nested data. This method is useful for programmatically expanding rows to display their hierarchical children, providing detailed views for nested data structures.
Parameter | Type | Description |
---|---|---|
row | HTMLTableRowElement |
The table row element that should be expanded. |
record (optional) | Object |
Optional. Represents the data record associated with the row to be expanded. |
key (optional) | Object |
Optional. The primary key value that uniquely identifies the record. |
level (optional) | number |
Optional. Indicates the hierarchical level of the record within the TreeGrid. |
Returns void
Filters the TreeGrid rows based on a specified column and filter criteria. This method allows for dynamic filtering against column data using various operators and values, supporting case-sensitive filtering and accent sensitivity.
Parameter | Type | Description |
---|---|---|
fieldName | string |
The name of the column to apply the filter on. |
filterOperator | string |
The operator used to perform the filter (e.g., ‘equals’, ‘startswith’). |
filterValue | string | number | Date | boolean | number[] | string[] | Date[] | boolean[] |
The value to filter against. |
predicate (optional) | string |
The logical operator (‘AND’/‘OR’) to combine this filter with others. |
matchCase (optional) | boolean |
If true, the filter performs a case-sensitive match. |
ignoreAccent (optional) | boolean |
If true, the filter ignores diacritical marks. |
actualFilterValue (optional) | string |
The original value used for filtering, useful for distinguishing displayed and actual values. |
actualOperator (optional) | string |
The actual operator that is applied when different from the displayed operator. |
Returns void
Collects data changes (added, edited, and deleted) that have not been saved in batch mode. This allows you to view pending changes awaiting a commit to the data source.
Returns Object
Retrieves a cell element based on its row and column indices in the TreeGrid. This method is helpful for accessing cell-level elements for custom operations or styling.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
The index of the row containing the cell. |
columnIndex | number |
The index of the column containing the cell. |
Returns Element
Retrieves the records associated with rows that have their checkboxes checked. Facilitates operations that require information about specifically selected or interacted rows within the grid.
Returns Object[]
Retrieves the indices of rows that have their checkboxes checked. This can assist in programatically assessing which rows have been selected by checkbox interaction for further processing.
Returns number[]
Retrieves a column object by the column’s field name. This is typically used for obtaining the details of a column for configuration or data manipulation purposes.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns Column
Fetches a column object using the column’s unique identifier (UID). Useful in scenarios where columns do not have unique field names but are uniquely identifiable via UID.
Parameter | Type | Description |
---|---|---|
uid | string |
The unique identifier for the column. |
Returns Column
Retrieves the names of all column fields in the TreeGrid. This method provides a list of field names useful for dynamic operations or configuration where fields need to be enumerated or manipulated.
Returns string[]
Retrieves a column header element based on the field name of the column. This method helps to directly manipulate headers, such as applying custom styles.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the desired column. |
Returns Element
Acquires the column header element using the column’s index. Suitable for situations where direct column index is available and header access is needed for operations.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the column. |
Returns Element
Retrieves a column header element utilizing the column’s UID. Useful for precision access to header elements when UIDs are used uniquely to manage column identities.
Parameter | Type | Description |
---|---|---|
uid | string |
The UID of the column. |
Returns Element
Determines the column index by the specified field name. Helpful in converting field names to indices for operations that require numeric input for array or collection indexing.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns number
Determines the column index based on the unique identifier (UID). This can be crucial in scenarios that involve dynamic column management where UID provides an accurate reference.
Parameter | Type | Description |
---|---|---|
uid | string |
The UID of the column. |
Returns number
Fetches a collection of columns from the TreeGrid optionally refreshing the column model. Use this method to retrieve and optionally refresh the list of columns to ensure up-to-date configurations and settings.
Parameter | Type | Description |
---|---|---|
isRefresh (optional) | boolean |
Determines whether to refresh the grid’s column model. |
Returns Column[]
Retrieves the main content area of the TreeGrid. This method allows access to the main content DIV, which can be used for layout adjustments or adding custom elements.
Returns Element
Retrieves the content table element of the TreeGrid. This table contains the main data display area, allowing for interaction and data manipulation directly within the TreeGrid.
Returns Element
Retrieves the current set of records that are visible in the TreeGrid view. This method excludes any summary rows to focus on the main data set currently being viewed by the user.
Returns Object[]
Obtains the data handling modules used by the TreeGrid. This includes both the base data module for standard grid operations and the tree module for handling hierarchical data, giving complete access to data management capabilities.
Returns Object
Obtains all data row elements from the TreeGrid, excluding summary rows. Provides a way to access the visual representation of data for purposes like custom formatting or event binding.
Returns Element[]
Retrieves the footer content element of the TreeGrid, usually for styling or custom manipulation. This can be used to access the footer for adding custom functionality or styling purposes to enhance user interaction at the bottom of the grid.
Returns Element
Acquires the footer table element of the TreeGrid for layout management. Useful for manipulating the table’s structure or style beneath the grid content.
Returns Element
Gets a frozen left column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets a frozen right table cell by row and column index.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Specifies the row index. |
columnIndex | number |
Specifies the column index. |
Returns Element
Gets a frozen right column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets all the Tree Grid’s frozen right table data rows.
Returns Element[]
Gets a frozen right tables row element by index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the row index. |
Returns Element
Gets the Tree Grid’s frozen right content rows from frozen Tree Grid.
Returns Element[]
Retrieves the header content element of the TreeGrid. Mainly used for interacting with the header section, which includes column headers and any applied header styling or events.
Returns Element
Retrieves the header table element of the TreeGrid. This method is useful for direct access to the table structure where column headers are defined.
Returns Element
Gets a movable table cell by row and column index.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Specifies the row index. |
columnIndex | number |
Specifies the column index. |
Returns Element
Gets a movable column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets all the TreeGrid’s movable table data rows.
Returns Element[]
Gets a movable tables row by index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the row index. |
Returns Element
Gets the TreeGrid’s movable content rows from frozen treegrid.
Returns Element[]
Obtains the pager element of the TreeGrid. The pager enables navigation between pages when the TreeGrid displays paginated data.
Returns Element
Retrieves the primary key field names used in the TreeGrid. This information is crucial for identifying and manipulating unique rows.
Returns string[]
Fetches a specific row element based on its index in the TreeGrid. This provides a way to directly access and manipulate a row using its index.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the desired row. |
Returns Element
Provides detailed information about a row based on a specified target element. Integral for retrieving metadata such as row index or data object when working with events or complex tree structures.
Parameter | Type | Description |
---|---|---|
target | Element | EventTarget |
The target element or event triggering the request. |
Returns RowInfo
Retrieves all the TreeGrid row elements. This method is useful for accessing the HTML representation of the rows for further manipulation or inspection.
Returns HTMLTableRowElement[]
Retrieves the data records corresponding to the currently selected rows. This method provides the full record data for the selected rows, which is useful for data manipulation or extraction operations.
Returns Object[]
Retrieves the indexes of the selected cells within the selected rows. This can be useful for handling cell-specific operations, such as applying styles or editing values programmatically.
Returns ISelectedCell[]
Retrieves the indexes of the currently selected rows in the TreeGrid. This method is useful when you need to perform actions based on the selected rows, such as retrieving data or changing the selection.
Returns number[]
Retrieves the currently selected rows. Useful for obtaining the selected data elements for downstream processing.
Returns Element[]
Finds the unique identifier (UID) for a column based on its field name. UIDs are essential for precise identification and manipulation within complex grids.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns string
Retrieves all the columns that are currently set to be visible within the TreeGrid. Helps in understanding the user’s current view and can be used to dynamically adjust the visible columns.
Returns Column[]
Retrieves currently visible records according to the TreeGrid’s visual state. It considers row expansion and collapse states to return only those records that a user can currently interact with.
Returns Object[]
Navigates to a specified page number within the TreeGrid pagination. This can be used to programmatically change the page being viewed, allowing for scripted navigation through data.
Parameter | Type | Description |
---|---|---|
pageNo | number |
The page number to navigate to. Must be within valid page range. |
Returns void
Hides one or more columns based on the specified column names. Utilized to dynamically reduce the visibility of columns based on user roles or preferences.
Parameter | Type | Description |
---|---|---|
keys | string | string[] |
A single column name or an array of column names to hide. |
hideBy (optional) | string |
Key to evaluate columns either as field name or header text. |
Returns void
Hides a manually shown loading spinner overlay from the TreeGrid. Ensures that any long-running process indication is removed after completion to manage user interface aesthetics.
Returns void
Indents a specified record, promoting it to one level deeper in the hierarchy. This function moves the selected row to become the last child of its preceding row, altering the visual and hierarchical data structure.
Parameter | Type | Description |
---|---|---|
record (optional) | Object |
(Optional) The record to be indented. If omitted, the currently selected row is used. |
Returns void
Displays the column chooser at a specified screen position. Useful for customizing the visibility of columns interactively via the UI.
Parameter | Type | Description |
---|---|---|
x (optional) | number |
The X-axis position of the column chooser. |
y (optional) | number |
The Y-axis position of the column chooser. |
Returns void
Outdents a specified record, moving it one level up in the hierarchy. This method repositions the selected row to be a sibling of its parent, impacting its display and the hierarchical relationships within the TreeGrid.
Parameter | Type | Description |
---|---|---|
record (optional) | Object |
(Optional) The record to be outdented. If omitted, the currently selected row is used. |
Returns void
Pastes data into the selected cells from the clipboard. Automatically places the pasted data starting from the specified indices.
Parameter | Type | Description |
---|---|---|
data | string |
The clipboard data to paste. |
rowIndex | number |
The starting row index for pasting. |
colIndex | number |
The starting column index for pasting. |
Returns void
Exports the TreeGrid data to a PDF document.
Parameter | Type | Description |
---|---|---|
pdfExportProperties (optional) | PdfExportProperties | TreeGridPdfExportProperties |
The properties used to configure the PDF export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
pdfDoc (optional) | Object |
The PDF document instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Prints all the pages of the TreeGrid and hides the pager by default. Customize print options using the printMode.
Returns void
Refreshes the visual appearance and data of the TreeGrid, updating header and content. This is crucial for synchronizing the displayed data with the underlying data source, ensuring the view reflects current data.
Returns void
Updates and refreshes the TreeGrid’s column definitions and layout. Ensures that the latest column settings are displayed, either refreshing the UI or adjusting internal configurations to match current data or configuration updates.
Parameter | Type | Description |
---|---|---|
refreshUI (optional) | boolean |
A flag indicating whether the DOM should be updated. |
Returns void
Refreshes the header section of the TreeGrid to reflect any structural or data changes. This method is useful when there are dynamic updates or layout adjustments needed in the header portion to ensure it aligns with current grid data or settings.
Returns void
Reorders TreeGrid columns by specifying their field names.
Parameter | Type | Description |
---|---|---|
fromFName | string | string[] |
The field name(s) of the column(s) to be moved. |
toFName | string |
The destination field name to place the moved columns. |
Returns void
Reorders rows in the TreeGrid based on specified source indexes and a target position. This functionality allows for dynamic rearrangement of rows, such as moving selected rows to a new position as siblings or children.
Parameter | Type | Description |
---|---|---|
fromIndexes | number[] |
An array indicating the source indexes of the rows to be moved. |
toIndex | number |
The target index where the rows should be moved. |
position | string |
The position relative to the target index (‘above’, ‘below’, ‘child’). |
Returns void
Saves the current cell value changes without committing to the data source. This operation persists the changes in the UI but not in the underlying data model.
Returns void
Searches for TreeGrid records using a specified search string. Customize the search behavior through the searchSettings.
Parameter | Type | Description |
---|---|---|
searchString | string |
The string used as the search key. |
Returns void
Selects a cell by its index position in the TreeGrid. Useful for navigating or highlighting specific data cells within the grid.
Parameter | Type | Description |
---|---|---|
cellIndex | IIndex |
An object specifying the row and column indexes. |
isToggle (optional) | boolean |
(Optional) If true, toggles the selection state of the cell. |
Returns void
Selects rows in the TreeGrid using row indices, checking their associated checkboxes. This method provides automation for selecting or highlighting specific rows, useful in scenarios needing pre-selection or default selections.
Parameter | Type | Description |
---|---|---|
indexes | number[] |
An array of row indices to be marked as selected. |
Returns void
Selects a row in the TreeGrid by its index. Use this method to highlight a specific row; useful for programmatically navigating data.
Parameter | Type | Description |
---|---|---|
index | number |
Index of the row to select. |
isToggle (optional) | boolean |
If true, toggles the selection state of the row. |
Returns void
Selects multiple rows in the TreeGrid given an array of row indexes. Useful for batch operations where multiple row selections are necessary.
Parameter | Type | Description |
---|---|---|
rowIndexes | number[] |
Array of row index numbers to select. |
Returns void
Sends a POST request to export the TreeGrid to a CSV file on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side CSV export action. |
Returns void
Sends a POST request to export the TreeGrid to an Excel file on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side Excel export action. |
Returns void
Sends a POST request to export the TreeGrid to a PDF document on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side PDF export action. |
Returns void
Updates the value of a specific cell using its primary key for identification. Useful for targeted updates that leverage unique identifiers to ensure accuracy.
Parameter | Type | Description |
---|---|---|
key | string | number |
The primary key value of the row containing the cell. |
field | string |
The field name of the cell to update. |
value | string | number | boolean | Date |
The new value to assign to the specified cell. |
Returns void
Updates the data for a specific row identified by its primary key and refreshes the display. Important for keeping the displayed data consistent with the source database or dataset.
Parameter | Type | Description |
---|---|---|
key | string | number |
The primary key value of the row to update. |
rowData (optional) | ITreeData |
The new data to apply to the row. |
Returns void
Shows one or more columns based on the specified column names. This is useful for dynamically adjusting the visibility of columns based on user actions or application logic.
Parameter | Type | Description |
---|---|---|
keys | string | string[] |
A single column name or an array of column names to show. |
showBy (optional) | string |
Key to determine visibility either as field name or header text. |
Returns void
Displays a loading spinner overlay across the TreeGrid for any data action or long-running process. This can be manually invoked to indicate processing, enhancing user experience by providing feedback.
Returns void
Sorts a column with the specified options.
Parameter | Type | Description |
---|---|---|
columnName | string |
The name of the column to be sorted. |
direction | SortDirection |
The direction of the sorting operation. |
isMultiSort (optional) | boolean |
Specifies whether previous sorted columns should be maintained during sorting. |
Returns void
Initiates editing for a specific row using its HTML element. This allows for manual control of which row enters edit mode through the UI.
Parameter | Type | Description |
---|---|---|
row (optional) | HTMLTableRowElement |
The table row element to enter into edit mode. |
Returns void
Updates the value of a specific cell directly, bypassing the edit mode. This method provides a quick way to update the UI and data without user interaction.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Defines the row index. |
field | string |
Defines the column field. |
value | string | number | boolean | Date |
Defines the value to be changed. |
Returns void
Updates the external message displayed within the pager component. This is useful for showing custom messages or additional information related to the data set or pagination status.
Parameter | Type | Description |
---|---|---|
message | string |
The custom message to display in the pager. |
Returns void
Updates a specific row with given values directly, skipping the edit state. This method allows for bulk updates of row data programmatically.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the row to update. |
data | Object |
The data object containing updated field values. |
Returns void
EmitType<PageEventArgs|FilterEventArgs|SortEventArgs|SearchEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs>
Triggers when TreeGrid actions like sorting, filtering, paging, etc., start.
EmitType<PageEventArgs|FilterEventArgs|SortEventArgs|SearchEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs>
Triggers when TreeGrid actions like sorting, filtering, paging, etc., are completed.
EmitType<FailureEventArgs>
Triggers when any TreeGrid action fails to achieve the desired results.
EmitType<BatchAddArgs>
Triggers when records are added in batch mode.
EmitType<BatchCancelArgs>
Triggers before records are cancelled in batch mode.
EmitType<BatchDeleteArgs>
Triggers when records are deleted in batch mode.
EmitType<BeforeBatchAddArgs>
Triggers before records are added in batch mode.
EmitType<BeforeBatchDeleteArgs>
Triggers before records are deleted in batch mode.
EmitType<BeforeBatchSaveArgs>
Triggers before records are saved in batch mode.
EmitType<BeforeCopyEventArgs>
Triggers before the TreeGrid copy action is initiated.
EmitType<BeforeDataBoundArgs>
Triggers before data is bound to the TreeGrid.
EmitType<Object>
Triggers before TreeGrid data is exported to an Excel file.
EmitType<BeforePasteEventArgs>
Triggers before the TreeGrid paste action is initiated.
EmitType<Object>
Triggers before TreeGrid data is exported to a PDF document.
EmitType<PrintEventArgs>
Triggers before the print action begins.
EmitType<BeginEditArgs>
Triggers before a record is edited.
EmitType<CellDeselectEventArgs>
Triggers when a selected cell is deselected.
EmitType<CellDeselectEventArgs>
Triggers before a selected cell is deselected.
EmitType<CellEditArgs>
Triggers when a cell is being edited.
EmitType<CellSaveArgs>
Triggers when a cell is being saved.
EmitType<CellSaveArgs>
Triggers after a cell is saved.
EmitType<CellSelectEventArgs>
Triggers after a cell is selected.
EmitType<CellSelectingEventArgs>
Triggers before any cell selection occurs.
EmitType<CheckBoxChangeEventArgs>
Triggers when the state of a checkbox changes in a checkbox column.
EmitType<RowCollapsedEventArgs>
Triggers after a TreeGrid record is collapsed.
EmitType<RowCollapsingEventArgs>
Triggers while a TreeGrid record is collapsing.
EmitType<ColumnDragEventArgs>
Triggers continuously while the column header is being dragged.
EmitType<ColumnDragEventArgs>
Triggers when column header dragging begins.
EmitType<ColumnDragEventArgs>
Triggers when a column header is dropped onto the target column.
EmitType<MenuEventArgs>
Triggers when there is a click on the column menu.
EmitType<ColumnMenuOpenEventArgs>
Triggers before the column menu opens.
EmitType<MenuEventArgs>
Triggers when an item in the context menu is clicked.
EmitType<BeforeOpenCloseMenuEventArgs>
Triggers before the context menu opens.
EmitType<Object>
Triggers when the component is created.
EmitType<Object>
Triggers when the data source is populated in the TreeGrid.
EmitType<DataSourceChangedEventArgs>
Triggers when data in the TreeGrid is added, deleted, or updated. Invoke the done method from the argument to start rendering after an edit operation.
EmitType<DataStateChangeEventArgs>
Triggers when TreeGrid actions such as sorting, paging, etc., are completed. The current view data and total record count should be assigned to the dataSource based on the action performed.
EmitType<DetailDataBoundEventArgs>
Triggers after a detail row expands. This event triggers initially during the first expand.
EmitType<ExcelExportCompleteArgs>
Triggers after TreeGrid data is exported to an Excel file.
EmitType<ExcelHeaderQueryCellInfoEventArgs>
Triggers before each header cell is exported to an Excel file, allowing customization of cells.
EmitType<ExcelQueryCellInfoEventArgs>
Triggers before each cell is exported to an Excel file, allowing customization of cells.
EmitType<RowExpandedEventArgs>
Triggers after a TreeGrid record is expanded.
EmitType<RowExpandingEventArgs>
Triggers while a TreeGrid record is expanding.
EmitType<HeaderCellInfoEventArgs>
Triggered for accessing header information.
EmitType<Object>
Allows customization of TreeGrid properties before rendering.
EmitType<PdfExportCompleteArgs>
Triggers after TreeGrid data is exported to a PDF document.
EmitType<PdfHeaderQueryCellInfoEventArgs>
Triggers before each header cell is exported to a PDF document, allowing customization of cells.
EmitType<PdfQueryCellInfoEventArgs>
Triggers before each cell is exported to a PDF document, allowing customization of cells.
EmitType<PrintEventArgs>
Triggers after the print action has been completed.
EmitType<QueryCellInfoEventArgs>
Triggered every time a request is made to access cell information, element, or data. This event is triggered before the cell element is appended to the TreeGrid element.
EmitType<RecordDoubleClickEventArgs>
Triggers when a record is double-clicked.
EmitType<ResizeArgs>
Triggers when column resizing starts.
EmitType<ResizeArgs>
Triggers when column resizing ends.
EmitType<ResizeArgs>
Triggers during column resizing.
EmitType<RowDataBoundEventArgs>
Triggered every time a request is made to access row information, element, or data. This event is triggered before the row element is appended to the TreeGrid element.
EmitType<RowDeselectEventArgs>
Triggers when a selected row is deselected.
EmitType<RowDeselectEventArgs>
Triggers before the selected row is deselected.
EmitType<RowDragEventArgs>
Triggers continuously while row elements are being dragged.
EmitType<RowDragEventArgs>
Triggers when row element dragging starts.
EmitType<RowDragEventArgs>
Triggers just before the row element dragging begins.
EmitType<RowDragEventArgs>
Triggers when a row element is dropped onto the target row.
EmitType<RowSelectEventArgs>
Triggers after a row is selected.
EmitType<RowSelectingEventArgs>
Triggers before row selection occurs.
EmitType<ClickEventArgs>
Triggers when a toolbar item is clicked.

ejs-treegrid
represents the Angular TreeTreeGrid Component.
<ejs-treegrid [dataSource]='data' allowPaging='true' allowSorting='true'></ejs-treegrid>
Configures the TreeGrid aggregate rows.
Check the Aggregates for its configuration.
Defaults to []
boolean
Enables exporting the TreeGrid to an Excel file if set to true.
Check the ExcelExport documentation for more details.
Defaults to false
boolean
If allowFiltering
is set to true the filter bar will be displayed.
If set to false the filter bar will not be displayed.
Filter bar allows the user to filter tree grid records with required criteria.
Defaults to false
boolean
If allowMultiSorting
set to true, then it will allow the user to sort multiple column in the treegrid.
allowSorting
should be true.
Defaults to true
boolean
If allowPaging
is set to true, pager renders.
Defaults to false
boolean
Enables exporting the TreeGrid to a PDF file if set to true.
Check the PdfExport documentation for more details.
Defaults to false
boolean
If allowReordering
is set to true, TreeGrid columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.
If TreeGrid is rendered with stacked headers, reordering is allowed only at the same level as the column headers.
Defaults to false
boolean
If allowResizing
is set to true, TreeGrid columns can be resized.
Defaults to false
boolean
If allowRowDragAndDrop
is set to true, row reordering functionality is enabled, allowing rows to be dragged
and dropped within the TreeGrid or across TreeGrids.
This feature enables users to reorganize data dynamically via drag-and-drop operations.
Defaults to false
boolean
If allowSelection
is set to true, selection of (highlight row) TreeGrid records by clicking is allowed.
Defaults to true
boolean
If allowSorting
is set to true, it allows sorting of treegrid records when column header is clicked.
Defaults to false
boolean
If allowTextWrap
set to true,
then text content will wrap to the next line when its text content exceeds the width of the Column Cells.
Defaults to false
boolean
If autoCheckHierarchy
is set to true, hierarchy checkbox selection is enabled in TreeGrid.
Defaults to false
string
Specifies the mapping property path for child records in data source
<ejs-treegrid #treegrid [dataSource]='data' childMapping='subtasks' [treeColumnIndex]='1'></ejs-treegrid>
Defaults to null
ClipMode
Defines the options for printing the TreeGrid. The available print modes are:
AllPages
: Prints all pages of the TreeGrid.CurrentPage
: Prints only the current page of the TreeGrid.Defaults to Syncfusion.EJ2.Grids.ClipMode.Ellipsis
TreeClipboard
clipboardModule
is used to handle TreeGrid copy action.
ColumnMenuItem[]
| ColumnMenuItemModel[]
columnMenuItems
defines both built-in and custom column menu items.
The available built-in items are,
AutoFitAll
- Auto fit the size of all columns.AutoFit
- Auto fit the current column.SortAscending
- Sort the current column in ascending order.SortDescending
- Sort the current column in descending order.Filter
- Filter options will show based on filterSettings property like filterbar, menu filter.Defaults to null
ColumnMenu
The columnMenuModule
is used to manipulate column menu items and its action in TreeGrid.
ColumnQueryModeType
Specifies how data is retrieved from the data source for the TreeGrid. The available modes are:
All
: Retrieve the entire data source.Schema
: Retrieve data only for defined columns.ExcludeHidden
: Retrieve data only for visible columns in the TreeGrid.Defaults to All
ColumnModel[]
| string[]
| Column[]
Defines the schema of dataSource.
If the columns
declaration is empty or undefined then the columns
are automatically generated from data source.
<ejs-treegrid #treegrid [dataSource]='data' childMapping='subtasks' [treeColumnIndex]='1'>
<e-columns>
<e-column field='taskID' headerText='Task ID' width='70' textAlign='Right'></e-column>
<e-column field='taskName' headerText='Task Name' width='200'></e-column>
<e-column field='duration' headerText='Duration' width='80' textAlign='Right'></e-column>
<e-column field='progress' headerText='Progress' width='80' textAlign='Right'></e-column>
</e-columns>
</ejs-treegrid>
Defaults to []
ContextMenuItem[]
| ContextMenuItemModel[]
contextMenuItems
defines both built-in and custom context menu items.
The available built-in items are,
AutoFitAll
- Auto fit the size of all columns.AutoFit
- Auto fit the current column.Edit
- Edit the current record.Delete
- Delete the current record.Save
- Save the edited record.Cancel
- Cancel the edited state.PdfExport
- Export the grid as Pdf format.ExcelExport
- Export the grid as Excel format.CsvExport
- Export the grid as CSV format.SortAscending
- Sort the current column in ascending order.SortDescending
- Sort the current column in descending order.FirstPage
- Go to the first page.PrevPage
- Go to the previous page.LastPage
- Go to the last page.NextPage
- Go to the next page.Defaults to null
ContextMenu
The contextMenuModule
is used to handle context menu items and its action in the TreeGrid.
copyHierarchyMode
Defines the copy clipboard types.
The available built-in items are,
Parent
- Copy the selected data with parent record.Child
- Copy the selected data with child record.Both
- Copy the selected data with both parent and child record.None
- Copy only the selected record.Defaults to Parent
Object
| DataManager
It is used to render TreeGrid table rows.
<ejs-treegrid #treegrid [dataSource]='data' childMapping='subtasks' [treeColumnIndex]='1'></ejs-treegrid>
import { Component, OnInit } from '@angular/core';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';
import { sampleData } from './jsontreegriddata';
@Component({
selector: 'app-root',
templateUrl: 'app.component.html'
})
export class AppComponent {
constructor() {}
public data: Object[] = [];
ngOnInit(): void {
this.data = sampleData;
}
}
Defaults to []
any
The detail template allows you to show or hide additional information about a particular row.
It accepts either the template string or the HTML element ID.
The editModule
is used to handle TreeGrid content manipulation.
Configures the edit settings.
Defaults to { allowAdding: false, allowEditing: false, allowDeleting: false, mode:‘Normal’,allowEditOnDblClick: true, showConfirmDialog: true, showDeleteConfirmDialog: false }
boolean
If enableAdaptiveUI
is set to true, the pop-up UI will become adaptive to small screens,
and be used for filtering and other features.
<div id='treegrid'></div>
<script>
var treegridObj = new TreeGrid({ enableAdaptiveUI: true });
treegridObj.appendTo('#treegrid');
</script>
Defaults to false
boolean
If enableAltRow
is set to true, the TreeGrid will render with e-altrow
CSS class to the alternative tr elements.
Check the AltRow to customize the styles of alternative rows.
Defaults to true
boolean
If enableAutoFill
is set to true, then the auto fill icon will displayed on cell selection for copy cells.
It requires the selection mode
to be Cell and cellSelectionMode
to be Box
.
Defaults to false
boolean
Specifies whether to load all rows in a collapsed state when the TreeGrid is initially rendered. This setting is particularly useful when dealing with large datasets, as it helps enhance loading performance by reducing initial data rendering.
Defaults to false
boolean
Enables column virtualization in the TreeGrid. When set to true
, only columns visible within the viewport are rendered.
Additional columns are loaded as you horizontally scroll. This is beneficial for rendering large datasets efficiently.
Defaults to false
boolean
If enableHover
is set to true, the row hover is enabled in the TreeGrid.
Defaults to false
boolean
Determines whether to sanitize untrusted HTML content in the TreeGrid. If true
, potentially harmful HTML strings
and scripts are sanitized before rendering to protect against XSS attacks.
Defaults to false
boolean
If enableImmutableMode
is set to true, the TreeGrid will reuse old rows if it exists in the new result instead of
full refresh while performing the TreeGrid actions.
Defaults to false
boolean
Enables infinite scrolling in the TreeGrid. When set to true
, additional data is loaded as the scrollbar
reaches the end. Useful for handling large datasets.
Defaults to false
boolean
Enable or disable persisting component’s state between page reloads.
Defaults to false
boolean
Enable or disable rendering component in right to left direction.
Defaults to false
boolean
Specifies whether to display shimmer effect during scrolling action in virtual scrolling feature. If disabled, spinner is shown instead of shimmer effect.
Defaults to true
boolean
If enableVirtualization
set to true, then the TreeGrid will render only the rows visible within the view-port
and load subsequent rows on vertical scrolling. This helps to load large dataset in TreeGrid.
Defaults to false
string
Specifies the mapping property path for the expand status of a record in data source.
Defaults to null
Configures the filter settings of the TreeGrid.
Defaults to {columns: [], type: ‘FilterBar’, mode: ‘Immediate’, showFilterBarStatus: true, immediateModeDelay: 1500 , operators: {}}
number
Specifies the number of columns that should remain visible and fixed on the left side of the TreeGrid during horizontal scrolling. This feature ensures key columns, such as identifiers, stay visible while users scroll through data.
Defaults to 0
number
Specifies the number of rows that should remain visible and fixed at the top of the TreeGrid during scrolling. This feature helps improve readability in data-heavy grids by keeping the header rows or key rows visible.
Defaults to 0
GridLine
Defines how TreeGrid content lines are displayed, determining the visibility of vertical and horizontal lines.
Both
: Displays both horizontal and vertical grid lines.None
: Hides both horizontal and vertical grid lines.Horizontal
: Displays only horizontal grid lines.Vertical
: Displays only vertical grid lines.Default
: Adjusts line visibility based on the theme.Defaults to Syncfusion.EJ2.Grids.GridLine.Default
string
Specifies whether record is parent or not for the remote data binding
Defaults to null
string
| number
Defines the scrollable height of the TreeGrid content.
Defaults to ‘auto’
string
Specifies the name of the field in the dataSource, which contains the id of that row.
<ejs-treegrid #treegrid [dataSource]='data' idMapping='TaskID' parentIdMapping='parentID' [treeColumnIndex]='1'></ejs-treegrid>
Defaults to null
Configures settings for infinite scrolling.
Defaults to { enableCache: false, maxBlocks: 5, initialBlocks: 5 }
KeyboardEvents
The keyboardModule
is used to manipulate keyboard interactions in TreeGrid.
boolean
When enabled, only parent records would be rendered during the initial render and child records will be loaded only when expanding a parent record. This property is only applicable for remote data binding. Loading child records on demand can improve the performance of data-bound controls with a large number of records. Child records are only loaded when they are requested, rather than loading all child records at once.
Defaults to true
Configures the loading indicator of the Tree Grid. Specifies whether to display spinner or shimmer effect during the waiting time on any actions (paging, sorting, filtering, CRUD operations) performed in Tree Grid.
Defaults to {indicatorType: ‘Spinner’}
string
Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.
Defaults to ”
Configures the pager in the TreeGrid.
Defaults to {currentPage: 1, pageSize: 12, pageCount: 8, enableQueryString: false, pageSizes: false, template: null}
Page
The pagerModule
is used to manipulate paging in the TreeGrid.
string
Specifies the name of the field in the dataSource, which contains the parent’s id
<ejs-treegrid #treegrid [dataSource]='data' idMapping='TaskID' parentIdMapping='parentID' [treeColumnIndex]='1'></ejs-treegrid>
Defaults to null
PrintMode
Defines the options for printing the TreeGrid. The available print modes are:
AllPages
: Prints all pages of the TreeGrid.CurrentPage
: Prints only the current page of the TreeGrid.Defaults to Syncfusion.EJ2.Grids.PrintMode.AllPages
Print
The printModule
is used to handle the printing feature of the TreeGrid.
Query
Defines the external Query that will be executed along with data processing.
Defaults to null
Reorder
The reorderModule
is used to manipulate reordering in TreeGrid.
RowDD
The rowDragandDrop
is used to manipulate Row Reordering in TreeGrid.
RowDropSettingsModel
Configures the row drop settings of the TreeGrid.
number
Defines the height of TreeGrid rows.
Defaults to null
any
The row template that renders customized rows from the given template. By default, TreeGrid renders a table row for every data source item.
- It accepts either template string or HTML element ID.
- The row template must be a table row. Check the Row Template customization.
Configures the search settings of the TreeGrid.
Defaults to {search: [] , operators: {}}
number
Specifies the index of the row to be selected upon initial rendering. Also retrieves the index of the currently selected row.
Defaults to -1
Configures the selection behavior.
Defaults to {mode: ‘Row’, cellSelectionMode: ‘Flow’, type: ‘Single’}
boolean
If showColumnChooser
is set to true, it allows you to dynamically show or hide columns.
Defaults to false
boolean
If showColumnMenu
set to true, then it will enable the column menu options in each columns.
Check the Column menu for its configuration.
Defaults to false
Sort
The sortModule
is used to manipulate sorting in TreeGrid.
Configures the sort settings of the TreeGrid.
Defaults to {columns:[]}
Configures the text wrap in the TreeGrid.
Defaults to {wrapMode:“Both”}
[]
toolbar
defines the ToolBar items of the TreeGrid.
It contains built-in and custom toolbar items.
If a string value is assigned to the toolbar
option, it is considered as the template for the whole TreeGrid ToolBar.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the TreeGrid’s Toolbar.
The available built-in ToolBar items are:
Defaults to null
Toolbar
The toolbarModule
is used to manipulate ToolBar items and its action in the TreeGrid.
number
Specifies the index of the column that needs to have the expander button.
Defaults to 0
string
| number
Defines the TreeGrid width.
Defaults to ‘auto’
Adds a new record to the TreeGrid at the specified position or default location.
Parameter | Type | Description |
---|---|---|
data (optional) | Object |
Object containing the data for the new record. If omitted, an empty row is added. |
index (optional) | number |
The index at which the new row should be added. |
position (optional) | RowPosition |
Specifies the position of the new row (e.g., before, after or child). > Requires editSettings.allowAdding to be true. |
Returns void
Adjusts column widths to fit their content, ensuring content is displayed without wrapping or truncation.
autoFitColumns
method during the dataBound
event for initial rendering.Parameter | Type | Description |
---|---|---|
fieldNames (optional) | string | string[] |
The name(s) of the column(s) to be auto-fitted. |
Returns void
Clears all filters applied to the TreeGrid, restoring the view to show all records. This method is useful for resetting the grid to its unfiltered state.
Returns void
Deselects all selected rows and cells within the TreeGrid. Resets the selection state of the grid, which is useful after bulk operations.
Returns void
Clears all the sorted columns in the TreeGrid.
Returns void
Cancels the current edit operation on the TreeGrid. This method discards changes made to the row and exits the edit mode without saving.
Returns void
Collapses all rows in the TreeGrid, hiding all child rows and leaving only parent nodes visible. This method can be used to quickly minimize the view to only top-level data, which is helpful for summarizing or performing broad overviews of the dataset.
Returns void
Collapses all the records at the specified hierarchical level within the TreeGrid. This function helps in hiding child rows for all parent nodes at a given level, effectively reducing the visible depth of the hierarchical structure.
Parameter | Type | Description |
---|---|---|
level | number |
The hierarchical level at which parent rows should be collapsed. |
Returns void
Collapses a specific record identified by the provided primary key value. This method is useful for collapsing particular node in the TreeGrid when the parent rows need to be targeted individually by their unique key.
Parameter | Type | Description |
---|---|---|
key | Object |
The primary key value of the record to be collapsed. |
Returns void
Collapses the specified parent row in the TreeGrid. This method collapses the row associated with the provided HTMLTableRowElement, hiding any of its displayed child rows. It is typically used to manage the visibility of hierarchical data within a tree structure.
Parameter | Type | Description |
---|---|---|
row | HTMLTableRowElement |
The HTMLTableRowElement representing the parent row whose child rows are to be collapsed. |
record (optional) | Object |
(Optional) The data record associated with the row being collapsed. This can be used to access or manipulate the underlying data when collapsing the row. |
key (optional) | Object |
(Optional) The primary key value of the record. It can be used to identify the target record uniquely when collapsing the row, especially in cases where the row or record data needs to be referenced or logged. |
Returns void
Copies the data of selected rows or cells to the clipboard. This method supports including headers for better context when pasting elsewhere.
Parameter | Type | Description |
---|---|---|
withHeader (optional) | boolean |
(Optional) If true, includes column headers in the copied data. |
Returns void
Exports the TreeGrid data to a CSV file.
Parameter | Type | Description |
---|---|---|
excelExportProperties (optional) | ExcelExportProperties |
The properties used to configure the CSV export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
workbook (optional) | any |
The workbook instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Deletes a record based on specified criteria or the selected record if none specified.
Parameter | Type | Description |
---|---|---|
fieldName (optional) | string |
The name of the primary key field. |
data (optional) | Object |
The data object representing the record to delete. |
Returns void
Deletes a visible row from the TreeGrid using its HTML element. Apply this method when handling row deletions through DOM manipulations.
Parameter | Type | Description |
---|---|---|
tr | HTMLTableRowElement |
The table row element to remove. |
Returns void
Destroys the TreeGrid component by detaching event handlers, removing attributes and classes, and clearing the component’s DOM elements. This method ensures that all resources used by the TreeGrid are properly released and the component is cleaned up from the DOM to prevent memory leaks.
Returns void
Begins editing of a specific cell using row and field indices. Customers can programmatically specify which cell to edit without user input.
Parameter | Type | Description |
---|---|---|
rowIndex (optional) | number |
The index of the row containing the cell. |
field (optional) | string |
The field name of the cell to edit. |
Returns void
Enables or disables specified ToolBar items within the TreeGrid. This facilitates dynamic control of toolbar actions based on application logic.
Parameter | Type | Description |
---|---|---|
items | string[] |
Array of ToolBar item IDs to enable or disable. |
isEnable | boolean |
Boolean flag to determine whether to enable (true) or disable (false) items. |
Returns void
Commits the edits made to a record in edit mode, updating the data source. Use this method to finalize changes for rows in edit mode, ensuring persistence.
Returns void
Exports the TreeGrid data to an Excel file (.xlsx).
Parameter | Type | Description |
---|---|---|
excelExportProperties (optional) | ExcelExportProperties | TreeGridExcelExportProperties |
The properties used to configure the Excel export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
workbook (optional) | any |
The workbook instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Expands all rows in the TreeGrid, making the full hierarchy visible. This method should be used with caution on large datasets, as it makes all nodes and their child rows visible, which might affect performance.
Returns void
Expands all the records at the specified hierarchical level within the TreeGrid. This method is useful for visually expanding data at a certain depth, making all parent rows visible at the given level and their child rows accessible.
Parameter | Type | Description |
---|---|---|
level | number |
The hierarchical level at which parent rows should be expanded. |
Returns void
Expands a specific record identified by the provided primary key value. This method is useful for expanding particular node in the TreeGrid when the parent rows need to be targeted individually by their unique key.
Parameter | Type | Description |
---|---|---|
key | Object |
The primary key value of the record to be expanded. |
Returns void
Expands the specified parent row within the TreeGrid to reveal its nested data. This method is useful for programmatically expanding rows to display their hierarchical children, providing detailed views for nested data structures.
Parameter | Type | Description |
---|---|---|
row | HTMLTableRowElement |
The table row element that should be expanded. |
record (optional) | Object |
Optional. Represents the data record associated with the row to be expanded. |
key (optional) | Object |
Optional. The primary key value that uniquely identifies the record. |
level (optional) | number |
Optional. Indicates the hierarchical level of the record within the TreeGrid. |
Returns void
Filters the TreeGrid rows based on a specified column and filter criteria. This method allows for dynamic filtering against column data using various operators and values, supporting case-sensitive filtering and accent sensitivity.
Parameter | Type | Description |
---|---|---|
fieldName | string |
The name of the column to apply the filter on. |
filterOperator | string |
The operator used to perform the filter (e.g., ‘equals’, ‘startswith’). |
filterValue | string | number | Date | boolean | number[] | string[] | Date[] | boolean[] |
The value to filter against. |
predicate (optional) | string |
The logical operator (‘AND’/‘OR’) to combine this filter with others. |
matchCase (optional) | boolean |
If true, the filter performs a case-sensitive match. |
ignoreAccent (optional) | boolean |
If true, the filter ignores diacritical marks. |
actualFilterValue (optional) | string |
The original value used for filtering, useful for distinguishing displayed and actual values. |
actualOperator (optional) | string |
The actual operator that is applied when different from the displayed operator. |
Returns void
Collects data changes (added, edited, and deleted) that have not been saved in batch mode. This allows you to view pending changes awaiting a commit to the data source.
Returns Object
Retrieves a cell element based on its row and column indices in the TreeGrid. This method is helpful for accessing cell-level elements for custom operations or styling.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
The index of the row containing the cell. |
columnIndex | number |
The index of the column containing the cell. |
Returns Element
Retrieves the records associated with rows that have their checkboxes checked. Facilitates operations that require information about specifically selected or interacted rows within the grid.
Returns Object[]
Retrieves the indices of rows that have their checkboxes checked. This can assist in programatically assessing which rows have been selected by checkbox interaction for further processing.
Returns number[]
Retrieves a column object by the column’s field name. This is typically used for obtaining the details of a column for configuration or data manipulation purposes.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns Column
Fetches a column object using the column’s unique identifier (UID). Useful in scenarios where columns do not have unique field names but are uniquely identifiable via UID.
Parameter | Type | Description |
---|---|---|
uid | string |
The unique identifier for the column. |
Returns Column
Retrieves the names of all column fields in the TreeGrid. This method provides a list of field names useful for dynamic operations or configuration where fields need to be enumerated or manipulated.
Returns string[]
Retrieves a column header element based on the field name of the column. This method helps to directly manipulate headers, such as applying custom styles.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the desired column. |
Returns Element
Acquires the column header element using the column’s index. Suitable for situations where direct column index is available and header access is needed for operations.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the column. |
Returns Element
Retrieves a column header element utilizing the column’s UID. Useful for precision access to header elements when UIDs are used uniquely to manage column identities.
Parameter | Type | Description |
---|---|---|
uid | string |
The UID of the column. |
Returns Element
Determines the column index by the specified field name. Helpful in converting field names to indices for operations that require numeric input for array or collection indexing.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns number
Determines the column index based on the unique identifier (UID). This can be crucial in scenarios that involve dynamic column management where UID provides an accurate reference.
Parameter | Type | Description |
---|---|---|
uid | string |
The UID of the column. |
Returns number
Fetches a collection of columns from the TreeGrid optionally refreshing the column model. Use this method to retrieve and optionally refresh the list of columns to ensure up-to-date configurations and settings.
Parameter | Type | Description |
---|---|---|
isRefresh (optional) | boolean |
Determines whether to refresh the grid’s column model. |
Returns Column[]
Retrieves the main content area of the TreeGrid. This method allows access to the main content DIV, which can be used for layout adjustments or adding custom elements.
Returns Element
Retrieves the content table element of the TreeGrid. This table contains the main data display area, allowing for interaction and data manipulation directly within the TreeGrid.
Returns Element
Retrieves the current set of records that are visible in the TreeGrid view. This method excludes any summary rows to focus on the main data set currently being viewed by the user.
Returns Object[]
Obtains the data handling modules used by the TreeGrid. This includes both the base data module for standard grid operations and the tree module for handling hierarchical data, giving complete access to data management capabilities.
Returns Object
Obtains all data row elements from the TreeGrid, excluding summary rows. Provides a way to access the visual representation of data for purposes like custom formatting or event binding.
Returns Element[]
Retrieves the footer content element of the TreeGrid, usually for styling or custom manipulation. This can be used to access the footer for adding custom functionality or styling purposes to enhance user interaction at the bottom of the grid.
Returns Element
Acquires the footer table element of the TreeGrid for layout management. Useful for manipulating the table’s structure or style beneath the grid content.
Returns Element
Gets a frozen left column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets a frozen right table cell by row and column index.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Specifies the row index. |
columnIndex | number |
Specifies the column index. |
Returns Element
Gets a frozen right column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets all the Tree Grid’s frozen right table data rows.
Returns Element[]
Gets a frozen right tables row element by index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the row index. |
Returns Element
Gets the Tree Grid’s frozen right content rows from frozen Tree Grid.
Returns Element[]
Retrieves the header content element of the TreeGrid. Mainly used for interacting with the header section, which includes column headers and any applied header styling or events.
Returns Element
Retrieves the header table element of the TreeGrid. This method is useful for direct access to the table structure where column headers are defined.
Returns Element
Gets a movable table cell by row and column index.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Specifies the row index. |
columnIndex | number |
Specifies the column index. |
Returns Element
Gets a movable column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets all the TreeGrid’s movable table data rows.
Returns Element[]
Gets a movable tables row by index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the row index. |
Returns Element
Gets the TreeGrid’s movable content rows from frozen treegrid.
Returns Element[]
Obtains the pager element of the TreeGrid. The pager enables navigation between pages when the TreeGrid displays paginated data.
Returns Element
Retrieves the primary key field names used in the TreeGrid. This information is crucial for identifying and manipulating unique rows.
Returns string[]
Fetches a specific row element based on its index in the TreeGrid. This provides a way to directly access and manipulate a row using its index.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the desired row. |
Returns Element
Provides detailed information about a row based on a specified target element. Integral for retrieving metadata such as row index or data object when working with events or complex tree structures.
Parameter | Type | Description |
---|---|---|
target | Element | EventTarget |
The target element or event triggering the request. |
Returns RowInfo
Retrieves all the TreeGrid row elements. This method is useful for accessing the HTML representation of the rows for further manipulation or inspection.
Returns HTMLTableRowElement[]
Retrieves the data records corresponding to the currently selected rows. This method provides the full record data for the selected rows, which is useful for data manipulation or extraction operations.
Returns Object[]
Retrieves the indexes of the selected cells within the selected rows. This can be useful for handling cell-specific operations, such as applying styles or editing values programmatically.
Returns ISelectedCell[]
Retrieves the indexes of the currently selected rows in the TreeGrid. This method is useful when you need to perform actions based on the selected rows, such as retrieving data or changing the selection.
Returns number[]
Retrieves the currently selected rows. Useful for obtaining the selected data elements for downstream processing.
Returns Element[]
Finds the unique identifier (UID) for a column based on its field name. UIDs are essential for precise identification and manipulation within complex grids.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns string
Retrieves all the columns that are currently set to be visible within the TreeGrid. Helps in understanding the user’s current view and can be used to dynamically adjust the visible columns.
Returns Column[]
Retrieves currently visible records according to the TreeGrid’s visual state. It considers row expansion and collapse states to return only those records that a user can currently interact with.
Returns Object[]
Navigates to a specified page number within the TreeGrid pagination. This can be used to programmatically change the page being viewed, allowing for scripted navigation through data.
Parameter | Type | Description |
---|---|---|
pageNo | number |
The page number to navigate to. Must be within valid page range. |
Returns void
Hides one or more columns based on the specified column names. Utilized to dynamically reduce the visibility of columns based on user roles or preferences.
Parameter | Type | Description |
---|---|---|
keys | string | string[] |
A single column name or an array of column names to hide. |
hideBy (optional) | string |
Key to evaluate columns either as field name or header text. |
Returns void
Hides a manually shown loading spinner overlay from the TreeGrid. Ensures that any long-running process indication is removed after completion to manage user interface aesthetics.
Returns void
Indents a specified record, promoting it to one level deeper in the hierarchy. This function moves the selected row to become the last child of its preceding row, altering the visual and hierarchical data structure.
Parameter | Type | Description |
---|---|---|
record (optional) | Object |
(Optional) The record to be indented. If omitted, the currently selected row is used. |
Returns void
Displays the column chooser at a specified screen position. Useful for customizing the visibility of columns interactively via the UI.
Parameter | Type | Description |
---|---|---|
x (optional) | number |
The X-axis position of the column chooser. |
y (optional) | number |
The Y-axis position of the column chooser. |
Returns void
Outdents a specified record, moving it one level up in the hierarchy. This method repositions the selected row to be a sibling of its parent, impacting its display and the hierarchical relationships within the TreeGrid.
Parameter | Type | Description |
---|---|---|
record (optional) | Object |
(Optional) The record to be outdented. If omitted, the currently selected row is used. |
Returns void
Pastes data into the selected cells from the clipboard. Automatically places the pasted data starting from the specified indices.
Parameter | Type | Description |
---|---|---|
data | string |
The clipboard data to paste. |
rowIndex | number |
The starting row index for pasting. |
colIndex | number |
The starting column index for pasting. |
Returns void
Exports the TreeGrid data to a PDF document.
Parameter | Type | Description |
---|---|---|
pdfExportProperties (optional) | PdfExportProperties | TreeGridPdfExportProperties |
The properties used to configure the PDF export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
pdfDoc (optional) | Object |
The PDF document instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Prints all the pages of the TreeGrid and hides the pager by default. Customize print options using the printMode.
Returns void
Refreshes the visual appearance and data of the TreeGrid, updating header and content. This is crucial for synchronizing the displayed data with the underlying data source, ensuring the view reflects current data.
Returns void
Updates and refreshes the TreeGrid’s column definitions and layout. Ensures that the latest column settings are displayed, either refreshing the UI or adjusting internal configurations to match current data or configuration updates.
Parameter | Type | Description |
---|---|---|
refreshUI (optional) | boolean |
A flag indicating whether the DOM should be updated. |
Returns void
Refreshes the header section of the TreeGrid to reflect any structural or data changes. This method is useful when there are dynamic updates or layout adjustments needed in the header portion to ensure it aligns with current grid data or settings.
Returns void
Reorders TreeGrid columns by specifying their field names.
Parameter | Type | Description |
---|---|---|
fromFName | string | string[] |
The field name(s) of the column(s) to be moved. |
toFName | string |
The destination field name to place the moved columns. |
Returns void
Reorders rows in the TreeGrid based on specified source indexes and a target position. This functionality allows for dynamic rearrangement of rows, such as moving selected rows to a new position as siblings or children.
Parameter | Type | Description |
---|---|---|
fromIndexes | number[] |
An array indicating the source indexes of the rows to be moved. |
toIndex | number |
The target index where the rows should be moved. |
position | string |
The position relative to the target index (‘above’, ‘below’, ‘child’). |
Returns void
Saves the current cell value changes without committing to the data source. This operation persists the changes in the UI but not in the underlying data model.
Returns void
Searches for TreeGrid records using a specified search string. Customize the search behavior through the searchSettings.
Parameter | Type | Description |
---|---|---|
searchString | string |
The string used as the search key. |
Returns void
Selects a cell by its index position in the TreeGrid. Useful for navigating or highlighting specific data cells within the grid.
Parameter | Type | Description |
---|---|---|
cellIndex | IIndex |
An object specifying the row and column indexes. |
isToggle (optional) | boolean |
(Optional) If true, toggles the selection state of the cell. |
Returns void
Selects rows in the TreeGrid using row indices, checking their associated checkboxes. This method provides automation for selecting or highlighting specific rows, useful in scenarios needing pre-selection or default selections.
Parameter | Type | Description |
---|---|---|
indexes | number[] |
An array of row indices to be marked as selected. |
Returns void
Selects a row in the TreeGrid by its index. Use this method to highlight a specific row; useful for programmatically navigating data.
Parameter | Type | Description |
---|---|---|
index | number |
Index of the row to select. |
isToggle (optional) | boolean |
If true, toggles the selection state of the row. |
Returns void
Selects multiple rows in the TreeGrid given an array of row indexes. Useful for batch operations where multiple row selections are necessary.
Parameter | Type | Description |
---|---|---|
rowIndexes | number[] |
Array of row index numbers to select. |
Returns void
Sends a POST request to export the TreeGrid to a CSV file on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side CSV export action. |
Returns void
Sends a POST request to export the TreeGrid to an Excel file on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side Excel export action. |
Returns void
Sends a POST request to export the TreeGrid to a PDF document on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side PDF export action. |
Returns void
Updates the value of a specific cell using its primary key for identification. Useful for targeted updates that leverage unique identifiers to ensure accuracy.
Parameter | Type | Description |
---|---|---|
key | string | number |
The primary key value of the row containing the cell. |
field | string |
The field name of the cell to update. |
value | string | number | boolean | Date |
The new value to assign to the specified cell. |
Returns void
Updates the data for a specific row identified by its primary key and refreshes the display. Important for keeping the displayed data consistent with the source database or dataset.
Parameter | Type | Description |
---|---|---|
key | string | number |
The primary key value of the row to update. |
rowData (optional) | ITreeData |
The new data to apply to the row. |
Returns void
Shows one or more columns based on the specified column names. This is useful for dynamically adjusting the visibility of columns based on user actions or application logic.
Parameter | Type | Description |
---|---|---|
keys | string | string[] |
A single column name or an array of column names to show. |
showBy (optional) | string |
Key to determine visibility either as field name or header text. |
Returns void
Displays a loading spinner overlay across the TreeGrid for any data action or long-running process. This can be manually invoked to indicate processing, enhancing user experience by providing feedback.
Returns void
Sorts a column with the specified options.
Parameter | Type | Description |
---|---|---|
columnName | string |
The name of the column to be sorted. |
direction | SortDirection |
The direction of the sorting operation. |
isMultiSort (optional) | boolean |
Specifies whether previous sorted columns should be maintained during sorting. |
Returns void
Initiates editing for a specific row using its HTML element. This allows for manual control of which row enters edit mode through the UI.
Parameter | Type | Description |
---|---|---|
row (optional) | HTMLTableRowElement |
The table row element to enter into edit mode. |
Returns void
Updates the value of a specific cell directly, bypassing the edit mode. This method provides a quick way to update the UI and data without user interaction.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Defines the row index. |
field | string |
Defines the column field. |
value | string | number | boolean | Date |
Defines the value to be changed. |
Returns void
Updates the external message displayed within the pager component. This is useful for showing custom messages or additional information related to the data set or pagination status.
Parameter | Type | Description |
---|---|---|
message | string |
The custom message to display in the pager. |
Returns void
Updates a specific row with given values directly, skipping the edit state. This method allows for bulk updates of row data programmatically.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the row to update. |
data | Object |
The data object containing updated field values. |
Returns void
EmitType<PageEventArgs|FilterEventArgs|SortEventArgs|SearchEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs>
Triggers when TreeGrid actions like sorting, filtering, paging, etc., start.
EmitType<PageEventArgs|FilterEventArgs|SortEventArgs|SearchEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs>
Triggers when TreeGrid actions like sorting, filtering, paging, etc., are completed.
EmitType<FailureEventArgs>
Triggers when any TreeGrid action fails to achieve the desired results.
EmitType<BatchAddArgs>
Triggers when records are added in batch mode.
EmitType<BatchCancelArgs>
Triggers before records are cancelled in batch mode.
EmitType<BatchDeleteArgs>
Triggers when records are deleted in batch mode.
EmitType<BeforeBatchAddArgs>
Triggers before records are added in batch mode.
EmitType<BeforeBatchDeleteArgs>
Triggers before records are deleted in batch mode.
EmitType<BeforeBatchSaveArgs>
Triggers before records are saved in batch mode.
EmitType<BeforeCopyEventArgs>
Triggers before the TreeGrid copy action is initiated.
EmitType<BeforeDataBoundArgs>
Triggers before data is bound to the TreeGrid.
EmitType<Object>
Triggers before TreeGrid data is exported to an Excel file.
EmitType<BeforePasteEventArgs>
Triggers before the TreeGrid paste action is initiated.
EmitType<Object>
Triggers before TreeGrid data is exported to a PDF document.
EmitType<PrintEventArgs>
Triggers before the print action begins.
EmitType<BeginEditArgs>
Triggers before a record is edited.
EmitType<CellDeselectEventArgs>
Triggers when a selected cell is deselected.
EmitType<CellDeselectEventArgs>
Triggers before a selected cell is deselected.
EmitType<CellEditArgs>
Triggers when a cell is being edited.
EmitType<CellSaveArgs>
Triggers when a cell is being saved.
EmitType<CellSaveArgs>
Triggers after a cell is saved.
EmitType<CellSelectEventArgs>
Triggers after a cell is selected.
EmitType<CellSelectingEventArgs>
Triggers before any cell selection occurs.
EmitType<CheckBoxChangeEventArgs>
Triggers when the state of a checkbox changes in a checkbox column.
EmitType<RowCollapsedEventArgs>
Triggers after a TreeGrid record is collapsed.
EmitType<RowCollapsingEventArgs>
Triggers while a TreeGrid record is collapsing.
EmitType<ColumnDragEventArgs>
Triggers continuously while the column header is being dragged.
EmitType<ColumnDragEventArgs>
Triggers when column header dragging begins.
EmitType<ColumnDragEventArgs>
Triggers when a column header is dropped onto the target column.
EmitType<MenuEventArgs>
Triggers when there is a click on the column menu.
EmitType<ColumnMenuOpenEventArgs>
Triggers before the column menu opens.
EmitType<MenuEventArgs>
Triggers when an item in the context menu is clicked.
EmitType<BeforeOpenCloseMenuEventArgs>
Triggers before the context menu opens.
EmitType<Object>
Triggers when the component is created.
EmitType<Object>
Triggers when the data source is populated in the TreeGrid.
EmitType<DataSourceChangedEventArgs>
Triggers when data in the TreeGrid is added, deleted, or updated. Invoke the done method from the argument to start rendering after an edit operation.
EmitType<DataStateChangeEventArgs>
Triggers when TreeGrid actions such as sorting, paging, etc., are completed. The current view data and total record count should be assigned to the dataSource based on the action performed.
EmitType<DetailDataBoundEventArgs>
Triggers after a detail row expands. This event triggers initially during the first expand.
EmitType<ExcelExportCompleteArgs>
Triggers after TreeGrid data is exported to an Excel file.
EmitType<ExcelHeaderQueryCellInfoEventArgs>
Triggers before each header cell is exported to an Excel file, allowing customization of cells.
EmitType<ExcelQueryCellInfoEventArgs>
Triggers before each cell is exported to an Excel file, allowing customization of cells.
EmitType<RowExpandedEventArgs>
Triggers after a TreeGrid record is expanded.
EmitType<RowExpandingEventArgs>
Triggers while a TreeGrid record is expanding.
EmitType<HeaderCellInfoEventArgs>
Triggered for accessing header information.
EmitType<Object>
Allows customization of TreeGrid properties before rendering.
EmitType<PdfExportCompleteArgs>
Triggers after TreeGrid data is exported to a PDF document.
EmitType<PdfHeaderQueryCellInfoEventArgs>
Triggers before each header cell is exported to a PDF document, allowing customization of cells.
EmitType<PdfQueryCellInfoEventArgs>
Triggers before each cell is exported to a PDF document, allowing customization of cells.
EmitType<PrintEventArgs>
Triggers after the print action has been completed.
EmitType<QueryCellInfoEventArgs>
Triggered every time a request is made to access cell information, element, or data. This event is triggered before the cell element is appended to the TreeGrid element.
EmitType<RecordDoubleClickEventArgs>
Triggers when a record is double-clicked.
EmitType<ResizeArgs>
Triggers when column resizing starts.
EmitType<ResizeArgs>
Triggers when column resizing ends.
EmitType<ResizeArgs>
Triggers during column resizing.
EmitType<RowDataBoundEventArgs>
Triggered every time a request is made to access row information, element, or data. This event is triggered before the row element is appended to the TreeGrid element.
EmitType<RowDeselectEventArgs>
Triggers when a selected row is deselected.
EmitType<RowDeselectEventArgs>
Triggers before the selected row is deselected.
EmitType<RowDragEventArgs>
Triggers continuously while row elements are being dragged.
EmitType<RowDragEventArgs>
Triggers when row element dragging starts.
EmitType<RowDragEventArgs>
Triggers just before the row element dragging begins.
EmitType<RowDragEventArgs>
Triggers when a row element is dropped onto the target row.
EmitType<RowSelectEventArgs>
Triggers after a row is selected.
EmitType<RowSelectingEventArgs>
Triggers before row selection occurs.
EmitType<ClickEventArgs>
Triggers when a toolbar item is clicked.

ejs-treegrid
represents the VueJS TreeGrid Component.
<ejs-treegrid :dataSource='data' allowPaging='true' allowSorting='true'></ejs-treegrid>
Configures the TreeGrid aggregate rows.
Check the Aggregates for its configuration.
Defaults to []
boolean
Enables exporting the TreeGrid to an Excel file if set to true.
Check the ExcelExport documentation for more details.
Defaults to false
boolean
If allowFiltering
is set to true the filter bar will be displayed.
If set to false the filter bar will not be displayed.
Filter bar allows the user to filter tree grid records with required criteria.
Defaults to false
boolean
If allowMultiSorting
set to true, then it will allow the user to sort multiple column in the treegrid.
allowSorting
should be true.
Defaults to true
boolean
If allowPaging
is set to true, pager renders.
Defaults to false
boolean
Enables exporting the TreeGrid to a PDF file if set to true.
Check the PdfExport documentation for more details.
Defaults to false
boolean
If allowReordering
is set to true, TreeGrid columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.
If TreeGrid is rendered with stacked headers, reordering is allowed only at the same level as the column headers.
Defaults to false
boolean
If allowResizing
is set to true, TreeGrid columns can be resized.
Defaults to false
boolean
If allowRowDragAndDrop
is set to true, row reordering functionality is enabled, allowing rows to be dragged
and dropped within the TreeGrid or across TreeGrids.
This feature enables users to reorganize data dynamically via drag-and-drop operations.
Defaults to false
boolean
If allowSelection
is set to true, selection of (highlight row) TreeGrid records by clicking is allowed.
Defaults to true
boolean
If allowSorting
is set to true, it allows sorting of treegrid records when column header is clicked.
Defaults to false
boolean
If allowTextWrap
set to true,
then text content will wrap to the next line when its text content exceeds the width of the Column Cells.
Defaults to false
boolean
If autoCheckHierarchy
is set to true, hierarchy checkbox selection is enabled in TreeGrid.
Defaults to false
string
Specifies the mapping property path for child records in data source
<template>
<div>
<ejs-treegrid :dataSource='data' childMapping='subtasks' :treeColumnIndex='1'>
</ejs-treegrid>
</div>
</template>
<script>
import Vue from "vue";
import { TreeGridPlugin } from "@syncfusion/ej2-vue-treegrid";
Vue.use(TreeGridPlugin);
export default {
data: function() {
return {
data: sampleData
};
}
};
</script>
Defaults to null
ClipMode
Defines the options for printing the TreeGrid. The available print modes are:
AllPages
: Prints all pages of the TreeGrid.CurrentPage
: Prints only the current page of the TreeGrid.Defaults to Syncfusion.EJ2.Grids.ClipMode.Ellipsis
TreeClipboard
clipboardModule
is used to handle TreeGrid copy action.
ColumnMenuItem[]
| ColumnMenuItemModel[]
columnMenuItems
defines both built-in and custom column menu items.
The available built-in items are,
AutoFitAll
- Auto fit the size of all columns.AutoFit
- Auto fit the current column.SortAscending
- Sort the current column in ascending order.SortDescending
- Sort the current column in descending order.Filter
- Filter options will show based on filterSettings property like filterbar, menu filter.Defaults to null
ColumnMenu
The columnMenuModule
is used to manipulate column menu items and its action in TreeGrid.
ColumnQueryModeType
Specifies how data is retrieved from the data source for the TreeGrid. The available modes are:
All
: Retrieve the entire data source.Schema
: Retrieve data only for defined columns.ExcludeHidden
: Retrieve data only for visible columns in the TreeGrid.Defaults to All
ColumnModel[]
| string[]
| Column[]
Defines the schema of dataSource.
If the columns
declaration is empty or undefined then the columns
are automatically generated from data source.
<template>
<div>
<ejs-treegrid :dataSource='data' childMapping='subtasks' :treeColumnIndex='1'>
<e-columns>
<e-column field='taskID' headerText='Task ID' width='70' textAlign='Right'></e-column>
<e-column field='taskName' headerText='Task Name' width='200'></e-column>
<e-column field='duration' headerText='Duration' width='80' textAlign='Right'></e-column>
<e-column field='progress' headerText='Progress' width='80' textAlign='Right'></e-column>
</e-columns>
</ejs-treegrid>
</div>
</template>
<script>
import Vue from "vue";
import { TreeGridPlugin } from "@syncfusion/ej2-vue-treegrid";
Vue.use(TreeGridPlugin);
export default {
data: function() {
return {
data: sampleData
};
}
};
</script>
Defaults to []
ContextMenuItem[]
| ContextMenuItemModel[]
contextMenuItems
defines both built-in and custom context menu items.
The available built-in items are,
AutoFitAll
- Auto fit the size of all columns.AutoFit
- Auto fit the current column.Edit
- Edit the current record.Delete
- Delete the current record.Save
- Save the edited record.Cancel
- Cancel the edited state.PdfExport
- Export the grid as Pdf format.ExcelExport
- Export the grid as Excel format.CsvExport
- Export the grid as CSV format.SortAscending
- Sort the current column in ascending order.SortDescending
- Sort the current column in descending order.FirstPage
- Go to the first page.PrevPage
- Go to the previous page.LastPage
- Go to the last page.NextPage
- Go to the next page.Defaults to null
ContextMenu
The contextMenuModule
is used to handle context menu items and its action in the TreeGrid.
copyHierarchyMode
Defines the copy clipboard types.
The available built-in items are,
Parent
- Copy the selected data with parent record.Child
- Copy the selected data with child record.Both
- Copy the selected data with both parent and child record.None
- Copy only the selected record.Defaults to Parent
Object
| DataManager
It is used to render TreeGrid table rows.
<template>
<div>
<ejs-treegrid :dataSource='data' childMapping='subtasks' :treeColumnIndex='1'>
</ejs-treegrid>
</div>
</template>
<script>
import Vue from "vue";
import { TreeGridPlugin } from "@syncfusion/ej2-vue-treegrid";
import { sampleData } from "./data-source";
Vue.use(TreeGridPlugin);
export default {
data: function() {
return {
data: sampleData
};
}
};
</script>
Defaults to []
string
| Function
The detail template allows you to show or hide additional information about a particular row.
It accepts either the template string or the HTML element ID.
The editModule
is used to handle TreeGrid content manipulation.
Configures the edit settings.
Defaults to { allowAdding: false, allowEditing: false, allowDeleting: false, mode:‘Normal’,allowEditOnDblClick: true, showConfirmDialog: true, showDeleteConfirmDialog: false }
boolean
If enableAdaptiveUI
is set to true, the pop-up UI will become adaptive to small screens,
and be used for filtering and other features.
<div id='treegrid'></div>
<script>
var treegridObj = new TreeGrid({ enableAdaptiveUI: true });
treegridObj.appendTo('#treegrid');
</script>
Defaults to false
boolean
If enableAltRow
is set to true, the TreeGrid will render with e-altrow
CSS class to the alternative tr elements.
Check the AltRow to customize the styles of alternative rows.
Defaults to true
boolean
If enableAutoFill
is set to true, then the auto fill icon will displayed on cell selection for copy cells.
It requires the selection mode
to be Cell and cellSelectionMode
to be Box
.
Defaults to false
boolean
Specifies whether to load all rows in a collapsed state when the TreeGrid is initially rendered. This setting is particularly useful when dealing with large datasets, as it helps enhance loading performance by reducing initial data rendering.
Defaults to false
boolean
Enables column virtualization in the TreeGrid. When set to true
, only columns visible within the viewport are rendered.
Additional columns are loaded as you horizontally scroll. This is beneficial for rendering large datasets efficiently.
Defaults to false
boolean
If enableHover
is set to true, the row hover is enabled in the TreeGrid.
Defaults to false
boolean
Determines whether to sanitize untrusted HTML content in the TreeGrid. If true
, potentially harmful HTML strings
and scripts are sanitized before rendering to protect against XSS attacks.
Defaults to false
boolean
If enableImmutableMode
is set to true, the TreeGrid will reuse old rows if it exists in the new result instead of
full refresh while performing the TreeGrid actions.
Defaults to false
boolean
Enables infinite scrolling in the TreeGrid. When set to true
, additional data is loaded as the scrollbar
reaches the end. Useful for handling large datasets.
Defaults to false
boolean
Enable or disable persisting component’s state between page reloads.
Defaults to false
boolean
Enable or disable rendering component in right to left direction.
Defaults to false
boolean
Specifies whether to display shimmer effect during scrolling action in virtual scrolling feature. If disabled, spinner is shown instead of shimmer effect.
Defaults to true
boolean
If enableVirtualization
set to true, then the TreeGrid will render only the rows visible within the view-port
and load subsequent rows on vertical scrolling. This helps to load large dataset in TreeGrid.
Defaults to false
string
Specifies the mapping property path for the expand status of a record in data source.
Defaults to null
Configures the filter settings of the TreeGrid.
Defaults to {columns: [], type: ‘FilterBar’, mode: ‘Immediate’, showFilterBarStatus: true, immediateModeDelay: 1500 , operators: {}}
number
Specifies the number of columns that should remain visible and fixed on the left side of the TreeGrid during horizontal scrolling. This feature ensures key columns, such as identifiers, stay visible while users scroll through data.
Defaults to 0
number
Specifies the number of rows that should remain visible and fixed at the top of the TreeGrid during scrolling. This feature helps improve readability in data-heavy grids by keeping the header rows or key rows visible.
Defaults to 0
GridLine
Defines how TreeGrid content lines are displayed, determining the visibility of vertical and horizontal lines.
Both
: Displays both horizontal and vertical grid lines.None
: Hides both horizontal and vertical grid lines.Horizontal
: Displays only horizontal grid lines.Vertical
: Displays only vertical grid lines.Default
: Adjusts line visibility based on the theme.Defaults to Syncfusion.EJ2.Grids.GridLine.Default
string
Specifies whether record is parent or not for the remote data binding
Defaults to null
string
| number
Defines the scrollable height of the TreeGrid content.
Defaults to ‘auto’
string
Specifies the name of the field in the dataSource, which contains the id of that row.
<template>
<div>
<ejs-treegrid :dataSource='data' idMapping='taskID' parentIdMapping='parentID' :treeColumnIndex='1'>
</ejs-treegrid>
</div>
</template>
<script>
import Vue from "vue";
import { TreeGridPlugin } from "@syncfusion/ej2-vue-treegrid";
Vue.use(TreeGridPlugin);
export default {
data: function() {
return {
data: sampleData
};
}
};
</script>
Defaults to null
Configures settings for infinite scrolling.
Defaults to { enableCache: false, maxBlocks: 5, initialBlocks: 5 }
KeyboardEvents
The keyboardModule
is used to manipulate keyboard interactions in TreeGrid.
boolean
When enabled, only parent records would be rendered during the initial render and child records will be loaded only when expanding a parent record. This property is only applicable for remote data binding. Loading child records on demand can improve the performance of data-bound controls with a large number of records. Child records are only loaded when they are requested, rather than loading all child records at once.
Defaults to true
Configures the loading indicator of the Tree Grid. Specifies whether to display spinner or shimmer effect during the waiting time on any actions (paging, sorting, filtering, CRUD operations) performed in Tree Grid.
Defaults to {indicatorType: ‘Spinner’}
string
Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.
Defaults to ”
Configures the pager in the TreeGrid.
Defaults to {currentPage: 1, pageSize: 12, pageCount: 8, enableQueryString: false, pageSizes: false, template: null}
Page
The pagerModule
is used to manipulate paging in the TreeGrid.
string
Specifies the name of the field in the dataSource, which contains the parent’s id
<template>
<div>
<ejs-treegrid :dataSource='data' idMapping='taskID' parentIdMapping='parentID' :treeColumnIndex='1'>
</ejs-treegrid>
</div>
</template>
<script>
import Vue from "vue";
import { TreeGridPlugin } from "@syncfusion/ej2-vue-treegrid";
Vue.use(TreeGridPlugin);
export default {
data: function() {
return {
data: sampleData
};
}
};
</script>
Defaults to null
PrintMode
Defines the options for printing the TreeGrid. The available print modes are:
AllPages
: Prints all pages of the TreeGrid.CurrentPage
: Prints only the current page of the TreeGrid.Defaults to Syncfusion.EJ2.Grids.PrintMode.AllPages
Print
The printModule
is used to handle the printing feature of the TreeGrid.
Query
Defines the external Query that will be executed along with data processing.
Defaults to null
Reorder
The reorderModule
is used to manipulate reordering in TreeGrid.
RowDD
The rowDragandDrop
is used to manipulate Row Reordering in TreeGrid.
RowDropSettingsModel
Configures the row drop settings of the TreeGrid.
number
Defines the height of TreeGrid rows.
Defaults to null
string
| Function
The row template that renders customized rows from the given template. By default, TreeGrid renders a table row for every data source item.
- It accepts either template string or HTML element ID.
- The row template must be a table row. Check the Row Template customization.
Configures the search settings of the TreeGrid.
Defaults to {search: [] , operators: {}}
number
Specifies the index of the row to be selected upon initial rendering. Also retrieves the index of the currently selected row.
Defaults to -1
Configures the selection behavior.
Defaults to {mode: ‘Row’, cellSelectionMode: ‘Flow’, type: ‘Single’}
boolean
If showColumnChooser
is set to true, it allows you to dynamically show or hide columns.
Defaults to false
boolean
If showColumnMenu
set to true, then it will enable the column menu options in each columns.
Check the Column menu for its configuration.
Defaults to false
Sort
The sortModule
is used to manipulate sorting in TreeGrid.
Configures the sort settings of the TreeGrid.
Defaults to {columns:[]}
Configures the text wrap in the TreeGrid.
Defaults to {wrapMode:“Both”}
[]
toolbar
defines the ToolBar items of the TreeGrid.
It contains built-in and custom toolbar items.
If a string value is assigned to the toolbar
option, it is considered as the template for the whole TreeGrid ToolBar.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the TreeGrid’s Toolbar.
The available built-in ToolBar items are:
Defaults to null
Toolbar
The toolbarModule
is used to manipulate ToolBar items and its action in the TreeGrid.
number
Specifies the index of the column that needs to have the expander button.
Defaults to 0
string
| number
Defines the TreeGrid width.
Defaults to ‘auto’
Adds a new record to the TreeGrid at the specified position or default location.
Parameter | Type | Description |
---|---|---|
data (optional) | Object |
Object containing the data for the new record. If omitted, an empty row is added. |
index (optional) | number |
The index at which the new row should be added. |
position (optional) | RowPosition |
Specifies the position of the new row (e.g., before, after or child). > Requires editSettings.allowAdding to be true. |
Returns void
Adjusts column widths to fit their content, ensuring content is displayed without wrapping or truncation.
autoFitColumns
method during the dataBound
event for initial rendering.Parameter | Type | Description |
---|---|---|
fieldNames (optional) | string | string[] |
The name(s) of the column(s) to be auto-fitted. |
Returns void
Clears all filters applied to the TreeGrid, restoring the view to show all records. This method is useful for resetting the grid to its unfiltered state.
Returns void
Deselects all selected rows and cells within the TreeGrid. Resets the selection state of the grid, which is useful after bulk operations.
Returns void
Clears all the sorted columns in the TreeGrid.
Returns void
Cancels the current edit operation on the TreeGrid. This method discards changes made to the row and exits the edit mode without saving.
Returns void
Collapses all rows in the TreeGrid, hiding all child rows and leaving only parent nodes visible. This method can be used to quickly minimize the view to only top-level data, which is helpful for summarizing or performing broad overviews of the dataset.
Returns void
Collapses all the records at the specified hierarchical level within the TreeGrid. This function helps in hiding child rows for all parent nodes at a given level, effectively reducing the visible depth of the hierarchical structure.
Parameter | Type | Description |
---|---|---|
level | number |
The hierarchical level at which parent rows should be collapsed. |
Returns void
Collapses a specific record identified by the provided primary key value. This method is useful for collapsing particular node in the TreeGrid when the parent rows need to be targeted individually by their unique key.
Parameter | Type | Description |
---|---|---|
key | Object |
The primary key value of the record to be collapsed. |
Returns void
Collapses the specified parent row in the TreeGrid. This method collapses the row associated with the provided HTMLTableRowElement, hiding any of its displayed child rows. It is typically used to manage the visibility of hierarchical data within a tree structure.
Parameter | Type | Description |
---|---|---|
row | HTMLTableRowElement |
The HTMLTableRowElement representing the parent row whose child rows are to be collapsed. |
record (optional) | Object |
(Optional) The data record associated with the row being collapsed. This can be used to access or manipulate the underlying data when collapsing the row. |
key (optional) | Object |
(Optional) The primary key value of the record. It can be used to identify the target record uniquely when collapsing the row, especially in cases where the row or record data needs to be referenced or logged. |
Returns void
Copies the data of selected rows or cells to the clipboard. This method supports including headers for better context when pasting elsewhere.
Parameter | Type | Description |
---|---|---|
withHeader (optional) | boolean |
(Optional) If true, includes column headers in the copied data. |
Returns void
Exports the TreeGrid data to a CSV file.
Parameter | Type | Description |
---|---|---|
excelExportProperties (optional) | ExcelExportProperties |
The properties used to configure the CSV export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
workbook (optional) | any |
The workbook instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Deletes a record based on specified criteria or the selected record if none specified.
Parameter | Type | Description |
---|---|---|
fieldName (optional) | string |
The name of the primary key field. |
data (optional) | Object |
The data object representing the record to delete. |
Returns void
Deletes a visible row from the TreeGrid using its HTML element. Apply this method when handling row deletions through DOM manipulations.
Parameter | Type | Description |
---|---|---|
tr | HTMLTableRowElement |
The table row element to remove. |
Returns void
Destroys the TreeGrid component by detaching event handlers, removing attributes and classes, and clearing the component’s DOM elements. This method ensures that all resources used by the TreeGrid are properly released and the component is cleaned up from the DOM to prevent memory leaks.
Returns void
Begins editing of a specific cell using row and field indices. Customers can programmatically specify which cell to edit without user input.
Parameter | Type | Description |
---|---|---|
rowIndex (optional) | number |
The index of the row containing the cell. |
field (optional) | string |
The field name of the cell to edit. |
Returns void
Enables or disables specified ToolBar items within the TreeGrid. This facilitates dynamic control of toolbar actions based on application logic.
Parameter | Type | Description |
---|---|---|
items | string[] |
Array of ToolBar item IDs to enable or disable. |
isEnable | boolean |
Boolean flag to determine whether to enable (true) or disable (false) items. |
Returns void
Commits the edits made to a record in edit mode, updating the data source. Use this method to finalize changes for rows in edit mode, ensuring persistence.
Returns void
Exports the TreeGrid data to an Excel file (.xlsx).
Parameter | Type | Description |
---|---|---|
excelExportProperties (optional) | ExcelExportProperties | TreeGridExcelExportProperties |
The properties used to configure the Excel export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
workbook (optional) | any |
The workbook instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Expands all rows in the TreeGrid, making the full hierarchy visible. This method should be used with caution on large datasets, as it makes all nodes and their child rows visible, which might affect performance.
Returns void
Expands all the records at the specified hierarchical level within the TreeGrid. This method is useful for visually expanding data at a certain depth, making all parent rows visible at the given level and their child rows accessible.
Parameter | Type | Description |
---|---|---|
level | number |
The hierarchical level at which parent rows should be expanded. |
Returns void
Expands a specific record identified by the provided primary key value. This method is useful for expanding particular node in the TreeGrid when the parent rows need to be targeted individually by their unique key.
Parameter | Type | Description |
---|---|---|
key | Object |
The primary key value of the record to be expanded. |
Returns void
Expands the specified parent row within the TreeGrid to reveal its nested data. This method is useful for programmatically expanding rows to display their hierarchical children, providing detailed views for nested data structures.
Parameter | Type | Description |
---|---|---|
row | HTMLTableRowElement |
The table row element that should be expanded. |
record (optional) | Object |
Optional. Represents the data record associated with the row to be expanded. |
key (optional) | Object |
Optional. The primary key value that uniquely identifies the record. |
level (optional) | number |
Optional. Indicates the hierarchical level of the record within the TreeGrid. |
Returns void
Filters the TreeGrid rows based on a specified column and filter criteria. This method allows for dynamic filtering against column data using various operators and values, supporting case-sensitive filtering and accent sensitivity.
Parameter | Type | Description |
---|---|---|
fieldName | string |
The name of the column to apply the filter on. |
filterOperator | string |
The operator used to perform the filter (e.g., ‘equals’, ‘startswith’). |
filterValue | string | number | Date | boolean | number[] | string[] | Date[] | boolean[] |
The value to filter against. |
predicate (optional) | string |
The logical operator (‘AND’/‘OR’) to combine this filter with others. |
matchCase (optional) | boolean |
If true, the filter performs a case-sensitive match. |
ignoreAccent (optional) | boolean |
If true, the filter ignores diacritical marks. |
actualFilterValue (optional) | string |
The original value used for filtering, useful for distinguishing displayed and actual values. |
actualOperator (optional) | string |
The actual operator that is applied when different from the displayed operator. |
Returns void
Collects data changes (added, edited, and deleted) that have not been saved in batch mode. This allows you to view pending changes awaiting a commit to the data source.
Returns Object
Retrieves a cell element based on its row and column indices in the TreeGrid. This method is helpful for accessing cell-level elements for custom operations or styling.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
The index of the row containing the cell. |
columnIndex | number |
The index of the column containing the cell. |
Returns Element
Retrieves the records associated with rows that have their checkboxes checked. Facilitates operations that require information about specifically selected or interacted rows within the grid.
Returns Object[]
Retrieves the indices of rows that have their checkboxes checked. This can assist in programatically assessing which rows have been selected by checkbox interaction for further processing.
Returns number[]
Retrieves a column object by the column’s field name. This is typically used for obtaining the details of a column for configuration or data manipulation purposes.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns Column
Fetches a column object using the column’s unique identifier (UID). Useful in scenarios where columns do not have unique field names but are uniquely identifiable via UID.
Parameter | Type | Description |
---|---|---|
uid | string |
The unique identifier for the column. |
Returns Column
Retrieves the names of all column fields in the TreeGrid. This method provides a list of field names useful for dynamic operations or configuration where fields need to be enumerated or manipulated.
Returns string[]
Retrieves a column header element based on the field name of the column. This method helps to directly manipulate headers, such as applying custom styles.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the desired column. |
Returns Element
Acquires the column header element using the column’s index. Suitable for situations where direct column index is available and header access is needed for operations.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the column. |
Returns Element
Retrieves a column header element utilizing the column’s UID. Useful for precision access to header elements when UIDs are used uniquely to manage column identities.
Parameter | Type | Description |
---|---|---|
uid | string |
The UID of the column. |
Returns Element
Determines the column index by the specified field name. Helpful in converting field names to indices for operations that require numeric input for array or collection indexing.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns number
Determines the column index based on the unique identifier (UID). This can be crucial in scenarios that involve dynamic column management where UID provides an accurate reference.
Parameter | Type | Description |
---|---|---|
uid | string |
The UID of the column. |
Returns number
Fetches a collection of columns from the TreeGrid optionally refreshing the column model. Use this method to retrieve and optionally refresh the list of columns to ensure up-to-date configurations and settings.
Parameter | Type | Description |
---|---|---|
isRefresh (optional) | boolean |
Determines whether to refresh the grid’s column model. |
Returns Column[]
Retrieves the main content area of the TreeGrid. This method allows access to the main content DIV, which can be used for layout adjustments or adding custom elements.
Returns Element
Retrieves the content table element of the TreeGrid. This table contains the main data display area, allowing for interaction and data manipulation directly within the TreeGrid.
Returns Element
Retrieves the current set of records that are visible in the TreeGrid view. This method excludes any summary rows to focus on the main data set currently being viewed by the user.
Returns Object[]
Obtains the data handling modules used by the TreeGrid. This includes both the base data module for standard grid operations and the tree module for handling hierarchical data, giving complete access to data management capabilities.
Returns Object
Obtains all data row elements from the TreeGrid, excluding summary rows. Provides a way to access the visual representation of data for purposes like custom formatting or event binding.
Returns Element[]
Retrieves the footer content element of the TreeGrid, usually for styling or custom manipulation. This can be used to access the footer for adding custom functionality or styling purposes to enhance user interaction at the bottom of the grid.
Returns Element
Acquires the footer table element of the TreeGrid for layout management. Useful for manipulating the table’s structure or style beneath the grid content.
Returns Element
Gets a frozen left column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets a frozen right table cell by row and column index.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Specifies the row index. |
columnIndex | number |
Specifies the column index. |
Returns Element
Gets a frozen right column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets all the Tree Grid’s frozen right table data rows.
Returns Element[]
Gets a frozen right tables row element by index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the row index. |
Returns Element
Gets the Tree Grid’s frozen right content rows from frozen Tree Grid.
Returns Element[]
Retrieves the header content element of the TreeGrid. Mainly used for interacting with the header section, which includes column headers and any applied header styling or events.
Returns Element
Retrieves the header table element of the TreeGrid. This method is useful for direct access to the table structure where column headers are defined.
Returns Element
Gets a movable table cell by row and column index.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Specifies the row index. |
columnIndex | number |
Specifies the column index. |
Returns Element
Gets a movable column header by column index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the column index. |
Returns Element
Gets all the TreeGrid’s movable table data rows.
Returns Element[]
Gets a movable tables row by index.
Parameter | Type | Description |
---|---|---|
index | number |
Specifies the row index. |
Returns Element
Gets the TreeGrid’s movable content rows from frozen treegrid.
Returns Element[]
Obtains the pager element of the TreeGrid. The pager enables navigation between pages when the TreeGrid displays paginated data.
Returns Element
Retrieves the primary key field names used in the TreeGrid. This information is crucial for identifying and manipulating unique rows.
Returns string[]
Fetches a specific row element based on its index in the TreeGrid. This provides a way to directly access and manipulate a row using its index.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the desired row. |
Returns Element
Provides detailed information about a row based on a specified target element. Integral for retrieving metadata such as row index or data object when working with events or complex tree structures.
Parameter | Type | Description |
---|---|---|
target | Element | EventTarget |
The target element or event triggering the request. |
Returns RowInfo
Retrieves all the TreeGrid row elements. This method is useful for accessing the HTML representation of the rows for further manipulation or inspection.
Returns HTMLTableRowElement[]
Retrieves the data records corresponding to the currently selected rows. This method provides the full record data for the selected rows, which is useful for data manipulation or extraction operations.
Returns Object[]
Retrieves the indexes of the selected cells within the selected rows. This can be useful for handling cell-specific operations, such as applying styles or editing values programmatically.
Returns ISelectedCell[]
Retrieves the indexes of the currently selected rows in the TreeGrid. This method is useful when you need to perform actions based on the selected rows, such as retrieving data or changing the selection.
Returns number[]
Retrieves the currently selected rows. Useful for obtaining the selected data elements for downstream processing.
Returns Element[]
Finds the unique identifier (UID) for a column based on its field name. UIDs are essential for precise identification and manipulation within complex grids.
Parameter | Type | Description |
---|---|---|
field | string |
The field name of the column. |
Returns string
Retrieves all the columns that are currently set to be visible within the TreeGrid. Helps in understanding the user’s current view and can be used to dynamically adjust the visible columns.
Returns Column[]
Retrieves currently visible records according to the TreeGrid’s visual state. It considers row expansion and collapse states to return only those records that a user can currently interact with.
Returns Object[]
Navigates to a specified page number within the TreeGrid pagination. This can be used to programmatically change the page being viewed, allowing for scripted navigation through data.
Parameter | Type | Description |
---|---|---|
pageNo | number |
The page number to navigate to. Must be within valid page range. |
Returns void
Hides one or more columns based on the specified column names. Utilized to dynamically reduce the visibility of columns based on user roles or preferences.
Parameter | Type | Description |
---|---|---|
keys | string | string[] |
A single column name or an array of column names to hide. |
hideBy (optional) | string |
Key to evaluate columns either as field name or header text. |
Returns void
Hides a manually shown loading spinner overlay from the TreeGrid. Ensures that any long-running process indication is removed after completion to manage user interface aesthetics.
Returns void
Indents a specified record, promoting it to one level deeper in the hierarchy. This function moves the selected row to become the last child of its preceding row, altering the visual and hierarchical data structure.
Parameter | Type | Description |
---|---|---|
record (optional) | Object |
(Optional) The record to be indented. If omitted, the currently selected row is used. |
Returns void
Displays the column chooser at a specified screen position. Useful for customizing the visibility of columns interactively via the UI.
Parameter | Type | Description |
---|---|---|
x (optional) | number |
The X-axis position of the column chooser. |
y (optional) | number |
The Y-axis position of the column chooser. |
Returns void
Outdents a specified record, moving it one level up in the hierarchy. This method repositions the selected row to be a sibling of its parent, impacting its display and the hierarchical relationships within the TreeGrid.
Parameter | Type | Description |
---|---|---|
record (optional) | Object |
(Optional) The record to be outdented. If omitted, the currently selected row is used. |
Returns void
Pastes data into the selected cells from the clipboard. Automatically places the pasted data starting from the specified indices.
Parameter | Type | Description |
---|---|---|
data | string |
The clipboard data to paste. |
rowIndex | number |
The starting row index for pasting. |
colIndex | number |
The starting column index for pasting. |
Returns void
Exports the TreeGrid data to a PDF document.
Parameter | Type | Description |
---|---|---|
pdfExportProperties (optional) | PdfExportProperties | TreeGridPdfExportProperties |
The properties used to configure the PDF export. |
isMultipleExport (optional) | boolean |
Indicates whether multiple exporting is enabled. |
pdfDoc (optional) | Object |
The PDF document instance used for multiple exports. |
isBlob (optional) | boolean |
If set to true, the result will be returned as blob data. |
Returns Promise
Prints all the pages of the TreeGrid and hides the pager by default. Customize print options using the printMode.
Returns void
Refreshes the visual appearance and data of the TreeGrid, updating header and content. This is crucial for synchronizing the displayed data with the underlying data source, ensuring the view reflects current data.
Returns void
Updates and refreshes the TreeGrid’s column definitions and layout. Ensures that the latest column settings are displayed, either refreshing the UI or adjusting internal configurations to match current data or configuration updates.
Parameter | Type | Description |
---|---|---|
refreshUI (optional) | boolean |
A flag indicating whether the DOM should be updated. |
Returns void
Refreshes the header section of the TreeGrid to reflect any structural or data changes. This method is useful when there are dynamic updates or layout adjustments needed in the header portion to ensure it aligns with current grid data or settings.
Returns void
Reorders TreeGrid columns by specifying their field names.
Parameter | Type | Description |
---|---|---|
fromFName | string | string[] |
The field name(s) of the column(s) to be moved. |
toFName | string |
The destination field name to place the moved columns. |
Returns void
Reorders rows in the TreeGrid based on specified source indexes and a target position. This functionality allows for dynamic rearrangement of rows, such as moving selected rows to a new position as siblings or children.
Parameter | Type | Description |
---|---|---|
fromIndexes | number[] |
An array indicating the source indexes of the rows to be moved. |
toIndex | number |
The target index where the rows should be moved. |
position | string |
The position relative to the target index (‘above’, ‘below’, ‘child’). |
Returns void
Saves the current cell value changes without committing to the data source. This operation persists the changes in the UI but not in the underlying data model.
Returns void
Searches for TreeGrid records using a specified search string. Customize the search behavior through the searchSettings.
Parameter | Type | Description |
---|---|---|
searchString | string |
The string used as the search key. |
Returns void
Selects a cell by its index position in the TreeGrid. Useful for navigating or highlighting specific data cells within the grid.
Parameter | Type | Description |
---|---|---|
cellIndex | IIndex |
An object specifying the row and column indexes. |
isToggle (optional) | boolean |
(Optional) If true, toggles the selection state of the cell. |
Returns void
Selects rows in the TreeGrid using row indices, checking their associated checkboxes. This method provides automation for selecting or highlighting specific rows, useful in scenarios needing pre-selection or default selections.
Parameter | Type | Description |
---|---|---|
indexes | number[] |
An array of row indices to be marked as selected. |
Returns void
Selects a row in the TreeGrid by its index. Use this method to highlight a specific row; useful for programmatically navigating data.
Parameter | Type | Description |
---|---|---|
index | number |
Index of the row to select. |
isToggle (optional) | boolean |
If true, toggles the selection state of the row. |
Returns void
Selects multiple rows in the TreeGrid given an array of row indexes. Useful for batch operations where multiple row selections are necessary.
Parameter | Type | Description |
---|---|---|
rowIndexes | number[] |
Array of row index numbers to select. |
Returns void
Sends a POST request to export the TreeGrid to a CSV file on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side CSV export action. |
Returns void
Sends a POST request to export the TreeGrid to an Excel file on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side Excel export action. |
Returns void
Sends a POST request to export the TreeGrid to a PDF document on the server side.
Parameter | Type | Description |
---|---|---|
url | string |
The URL for the server-side PDF export action. |
Returns void
Updates the value of a specific cell using its primary key for identification. Useful for targeted updates that leverage unique identifiers to ensure accuracy.
Parameter | Type | Description |
---|---|---|
key | string | number |
The primary key value of the row containing the cell. |
field | string |
The field name of the cell to update. |
value | string | number | boolean | Date |
The new value to assign to the specified cell. |
Returns void
Updates the data for a specific row identified by its primary key and refreshes the display. Important for keeping the displayed data consistent with the source database or dataset.
Parameter | Type | Description |
---|---|---|
key | string | number |
The primary key value of the row to update. |
rowData (optional) | ITreeData |
The new data to apply to the row. |
Returns void
Shows one or more columns based on the specified column names. This is useful for dynamically adjusting the visibility of columns based on user actions or application logic.
Parameter | Type | Description |
---|---|---|
keys | string | string[] |
A single column name or an array of column names to show. |
showBy (optional) | string |
Key to determine visibility either as field name or header text. |
Returns void
Displays a loading spinner overlay across the TreeGrid for any data action or long-running process. This can be manually invoked to indicate processing, enhancing user experience by providing feedback.
Returns void
Sorts a column with the specified options.
Parameter | Type | Description |
---|---|---|
columnName | string |
The name of the column to be sorted. |
direction | SortDirection |
The direction of the sorting operation. |
isMultiSort (optional) | boolean |
Specifies whether previous sorted columns should be maintained during sorting. |
Returns void
Initiates editing for a specific row using its HTML element. This allows for manual control of which row enters edit mode through the UI.
Parameter | Type | Description |
---|---|---|
row (optional) | HTMLTableRowElement |
The table row element to enter into edit mode. |
Returns void
Updates the value of a specific cell directly, bypassing the edit mode. This method provides a quick way to update the UI and data without user interaction.
Parameter | Type | Description |
---|---|---|
rowIndex | number |
Defines the row index. |
field | string |
Defines the column field. |
value | string | number | boolean | Date |
Defines the value to be changed. |
Returns void
Updates the external message displayed within the pager component. This is useful for showing custom messages or additional information related to the data set or pagination status.
Parameter | Type | Description |
---|---|---|
message | string |
The custom message to display in the pager. |
Returns void
Updates a specific row with given values directly, skipping the edit state. This method allows for bulk updates of row data programmatically.
Parameter | Type | Description |
---|---|---|
index | number |
The index of the row to update. |
data | Object |
The data object containing updated field values. |
Returns void
EmitType<PageEventArgs|FilterEventArgs|SortEventArgs|SearchEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs>
Triggers when TreeGrid actions like sorting, filtering, paging, etc., start.
EmitType<PageEventArgs|FilterEventArgs|SortEventArgs|SearchEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs>
Triggers when TreeGrid actions like sorting, filtering, paging, etc., are completed.
EmitType<FailureEventArgs>
Triggers when any TreeGrid action fails to achieve the desired results.
EmitType<BatchAddArgs>
Triggers when records are added in batch mode.
EmitType<BatchCancelArgs>
Triggers before records are cancelled in batch mode.
EmitType<BatchDeleteArgs>
Triggers when records are deleted in batch mode.
EmitType<BeforeBatchAddArgs>
Triggers before records are added in batch mode.
EmitType<BeforeBatchDeleteArgs>
Triggers before records are deleted in batch mode.
EmitType<BeforeBatchSaveArgs>
Triggers before records are saved in batch mode.
EmitType<BeforeCopyEventArgs>
Triggers before the TreeGrid copy action is initiated.
EmitType<BeforeDataBoundArgs>
Triggers before data is bound to the TreeGrid.
EmitType<Object>
Triggers before TreeGrid data is exported to an Excel file.
EmitType<BeforePasteEventArgs>
Triggers before the TreeGrid paste action is initiated.
EmitType<Object>
Triggers before TreeGrid data is exported to a PDF document.
EmitType<PrintEventArgs>
Triggers before the print action begins.
EmitType<BeginEditArgs>
Triggers before a record is edited.
EmitType<CellDeselectEventArgs>
Triggers when a selected cell is deselected.
EmitType<CellDeselectEventArgs>
Triggers before a selected cell is deselected.
EmitType<CellEditArgs>
Triggers when a cell is being edited.
EmitType<CellSaveArgs>
Triggers when a cell is being saved.
EmitType<CellSaveArgs>
Triggers after a cell is saved.
EmitType<CellSelectEventArgs>
Triggers after a cell is selected.
EmitType<CellSelectingEventArgs>
Triggers before any cell selection occurs.
EmitType<CheckBoxChangeEventArgs>
Triggers when the state of a checkbox changes in a checkbox column.
EmitType<RowCollapsedEventArgs>
Triggers after a TreeGrid record is collapsed.
EmitType<RowCollapsingEventArgs>
Triggers while a TreeGrid record is collapsing.
EmitType<ColumnDragEventArgs>
Triggers continuously while the column header is being dragged.
EmitType<ColumnDragEventArgs>
Triggers when column header dragging begins.
EmitType<ColumnDragEventArgs>
Triggers when a column header is dropped onto the target column.
EmitType<MenuEventArgs>
Triggers when there is a click on the column menu.
EmitType<ColumnMenuOpenEventArgs>
Triggers before the column menu opens.
EmitType<MenuEventArgs>
Triggers when an item in the context menu is clicked.
EmitType<BeforeOpenCloseMenuEventArgs>
Triggers before the context menu opens.
EmitType<Object>
Triggers when the component is created.
EmitType<Object>
Triggers when the data source is populated in the TreeGrid.
EmitType<DataSourceChangedEventArgs>
Triggers when data in the TreeGrid is added, deleted, or updated. Invoke the done method from the argument to start rendering after an edit operation.
EmitType<DataStateChangeEventArgs>
Triggers when TreeGrid actions such as sorting, paging, etc., are completed. The current view data and total record count should be assigned to the dataSource based on the action performed.
EmitType<DetailDataBoundEventArgs>
Triggers after a detail row expands. This event triggers initially during the first expand.
EmitType<ExcelExportCompleteArgs>
Triggers after TreeGrid data is exported to an Excel file.
EmitType<ExcelHeaderQueryCellInfoEventArgs>
Triggers before each header cell is exported to an Excel file, allowing customization of cells.
EmitType<ExcelQueryCellInfoEventArgs>
Triggers before each cell is exported to an Excel file, allowing customization of cells.
EmitType<RowExpandedEventArgs>
Triggers after a TreeGrid record is expanded.
EmitType<RowExpandingEventArgs>
Triggers while a TreeGrid record is expanding.
EmitType<HeaderCellInfoEventArgs>
Triggered for accessing header information.
EmitType<Object>
Allows customization of TreeGrid properties before rendering.
EmitType<PdfExportCompleteArgs>
Triggers after TreeGrid data is exported to a PDF document.
EmitType<PdfHeaderQueryCellInfoEventArgs>
Triggers before each header cell is exported to a PDF document, allowing customization of cells.
EmitType<PdfQueryCellInfoEventArgs>
Triggers before each cell is exported to a PDF document, allowing customization of cells.
EmitType<PrintEventArgs>
Triggers after the print action has been completed.
EmitType<QueryCellInfoEventArgs>
Triggered every time a request is made to access cell information, element, or data. This event is triggered before the cell element is appended to the TreeGrid element.
EmitType<RecordDoubleClickEventArgs>
Triggers when a record is double-clicked.
EmitType<ResizeArgs>
Triggers when column resizing starts.
EmitType<ResizeArgs>
Triggers when column resizing ends.
EmitType<ResizeArgs>
Triggers during column resizing.
EmitType<RowDataBoundEventArgs>
Triggered every time a request is made to access row information, element, or data. This event is triggered before the row element is appended to the TreeGrid element.
EmitType<RowDeselectEventArgs>
Triggers when a selected row is deselected.
EmitType<RowDeselectEventArgs>
Triggers before the selected row is deselected.
EmitType<RowDragEventArgs>
Triggers continuously while row elements are being dragged.
EmitType<RowDragEventArgs>
Triggers when row element dragging starts.
EmitType<RowDragEventArgs>
Triggers just before the row element dragging begins.
EmitType<RowDragEventArgs>
Triggers when a row element is dropped onto the target row.
EmitType<RowSelectEventArgs>
Triggers after a row is selected.
EmitType<RowSelectingEventArgs>
Triggers before row selection occurs.
EmitType<ClickEventArgs>
Triggers when a toolbar item is clicked.